"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Copyright (c) 2023 Arista Networks, Inc.  All rights reserved.
Use of this source code is governed by the Apache License 2.0
that can be found in the COPYING file.
"""

import builtins
import google.protobuf.descriptor
import google.protobuf.message
import google.protobuf.wrappers_pb2
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class ProbeKey(google.protobuf.message.Message):
    """ProbeKey uniquely identifies a connectivity monitor probe."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    DEVICE_ID_FIELD_NUMBER: builtins.int
    HOST_FIELD_NUMBER: builtins.int
    VRF_FIELD_NUMBER: builtins.int
    @property
    def device_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """device_id is the id of the device in the probe."""

    @property
    def host(self) -> google.protobuf.wrappers_pb2.StringValue:
        """host is the hostname used in the probe."""

    @property
    def vrf(self) -> google.protobuf.wrappers_pb2.StringValue:
        """vrf is the name of the VRF in the probe."""

    def __init__(
        self,
        *,
        device_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
        host: google.protobuf.wrappers_pb2.StringValue | None = ...,
        vrf: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["device_id", b"device_id", "host", b"host", "vrf", b"vrf"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["device_id", b"device_id", "host", b"host", "vrf", b"vrf"]) -> None: ...

global___ProbeKey = ProbeKey

@typing.final
class ProbeStatsKey(google.protobuf.message.Message):
    """ProbeStatsKey uniquely identifies a connectivity monitor probe's statistics,
    per source interface.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    DEVICE_ID_FIELD_NUMBER: builtins.int
    HOST_FIELD_NUMBER: builtins.int
    VRF_FIELD_NUMBER: builtins.int
    SOURCE_INTF_FIELD_NUMBER: builtins.int
    @property
    def device_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """device_id is the id of the device in the probe."""

    @property
    def host(self) -> google.protobuf.wrappers_pb2.StringValue:
        """host is the hostname used in the probe."""

    @property
    def vrf(self) -> google.protobuf.wrappers_pb2.StringValue:
        """vrf is the name of the VRF in the probe."""

    @property
    def source_intf(self) -> google.protobuf.wrappers_pb2.StringValue:
        """source_intf is the name of the interface in the probe."""

    def __init__(
        self,
        *,
        device_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
        host: google.protobuf.wrappers_pb2.StringValue | None = ...,
        vrf: google.protobuf.wrappers_pb2.StringValue | None = ...,
        source_intf: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["device_id", b"device_id", "host", b"host", "source_intf", b"source_intf", "vrf", b"vrf"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["device_id", b"device_id", "host", b"host", "source_intf", b"source_intf", "vrf", b"vrf"]) -> None: ...

global___ProbeStatsKey = ProbeStatsKey

@typing.final
class Probe(google.protobuf.message.Message):
    """Probe is identifying information of a connectivity monitor probe.
    It is used to retrieve probe information without getting the corresponding stats so that
    probe information can be displayed without streaming all related data, such as in the UI.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    IP_ADDR_FIELD_NUMBER: builtins.int
    HOST_NAME_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> global___ProbeKey:
        """key uniquely identifies the connectivity monitor probe."""

    @property
    def ip_addr(self) -> google.protobuf.wrappers_pb2.StringValue:
        """ip_addr is the IP Address of the probe."""

    @property
    def host_name(self) -> google.protobuf.wrappers_pb2.StringValue:
        """host_name is the name of the host of the probe."""

    @property
    def description(self) -> google.protobuf.wrappers_pb2.StringValue:
        """description is the description of the probe."""

    def __init__(
        self,
        *,
        key: global___ProbeKey | None = ...,
        ip_addr: google.protobuf.wrappers_pb2.StringValue | None = ...,
        host_name: google.protobuf.wrappers_pb2.StringValue | None = ...,
        description: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["description", b"description", "host_name", b"host_name", "ip_addr", b"ip_addr", "key", b"key"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["description", b"description", "host_name", b"host_name", "ip_addr", b"ip_addr", "key", b"key"]) -> None: ...

global___Probe = Probe

@typing.final
class ProbeStats(google.protobuf.message.Message):
    """ProbeStats is the connectivity monitor statistics related to the specified probe."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    LATENCY_MILLIS_FIELD_NUMBER: builtins.int
    JITTER_MILLIS_FIELD_NUMBER: builtins.int
    HTTP_RESPONSE_TIME_MILLIS_FIELD_NUMBER: builtins.int
    PACKET_LOSS_PERCENT_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> global___ProbeStatsKey:
        """key uniquely identifies the connectivity monitor probe."""

    @property
    def latency_millis(self) -> google.protobuf.wrappers_pb2.DoubleValue:
        """latency_millis is the latency between the device interface and the host.
        Value is in milliseconds.
        """

    @property
    def jitter_millis(self) -> google.protobuf.wrappers_pb2.DoubleValue:
        """jitter_millis is the amount of jitter experienced by requests
        between the device interface and host.
        Value is in milliseconds.
        """

    @property
    def http_response_time_millis(self) -> google.protobuf.wrappers_pb2.DoubleValue:
        """http_response_time_millis is the amount of time taken to respond to a http
        request between the device interface and the host.
        Value is in milliseconds.
        """

    @property
    def packet_loss_percent(self) -> google.protobuf.wrappers_pb2.Int64Value:
        """packet_loss_percent is the amount of packet loss experienced
        by requests between the device interface and host.
        Value is a percentage.
        """

    @property
    def error(self) -> google.protobuf.wrappers_pb2.StringValue:
        """error is the error reported on the connection."""

    def __init__(
        self,
        *,
        key: global___ProbeStatsKey | None = ...,
        latency_millis: google.protobuf.wrappers_pb2.DoubleValue | None = ...,
        jitter_millis: google.protobuf.wrappers_pb2.DoubleValue | None = ...,
        http_response_time_millis: google.protobuf.wrappers_pb2.DoubleValue | None = ...,
        packet_loss_percent: google.protobuf.wrappers_pb2.Int64Value | None = ...,
        error: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["error", b"error", "http_response_time_millis", b"http_response_time_millis", "jitter_millis", b"jitter_millis", "key", b"key", "latency_millis", b"latency_millis", "packet_loss_percent", b"packet_loss_percent"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["error", b"error", "http_response_time_millis", b"http_response_time_millis", "jitter_millis", b"jitter_millis", "key", b"key", "latency_millis", b"latency_millis", "packet_loss_percent", b"packet_loss_percent"]) -> None: ...

global___ProbeStats = ProbeStats
