"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Copyright (c) 2023 Arista Networks, Inc.  All rights reserved.
Use of this source code is governed by the Apache License 2.0
that can be found in the COPYING file.
"""

import builtins
import collections.abc
import fmp.wrappers_pb2
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import google.protobuf.timestamp_pb2
import google.protobuf.wrappers_pb2
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class Position(google.protobuf.message.Message):
    """Position represents a cell position in the UI."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    X_FIELD_NUMBER: builtins.int
    Y_FIELD_NUMBER: builtins.int
    @property
    def x(self) -> google.protobuf.wrappers_pb2.UInt32Value:
        """x represents a position in the horizontal axis."""

    @property
    def y(self) -> google.protobuf.wrappers_pb2.UInt32Value:
        """y represents a position in the vertical axis."""

    def __init__(
        self,
        *,
        x: google.protobuf.wrappers_pb2.UInt32Value | None = ...,
        y: google.protobuf.wrappers_pb2.UInt32Value | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["x", b"x", "y", b"y"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["x", b"x", "y", b"y"]) -> None: ...

global___Position = Position

@typing.final
class Dimensions(google.protobuf.message.Message):
    """Dimensions represents the dimensions in cells of the widgets in the UI."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    WIDTH_FIELD_NUMBER: builtins.int
    HEIGHT_FIELD_NUMBER: builtins.int
    @property
    def width(self) -> google.protobuf.wrappers_pb2.UInt32Value:
        """width of the widget in the UI, represented in number of cells."""

    @property
    def height(self) -> google.protobuf.wrappers_pb2.UInt32Value:
        """height of the widget in the UI, represented in number of cells."""

    def __init__(
        self,
        *,
        width: google.protobuf.wrappers_pb2.UInt32Value | None = ...,
        height: google.protobuf.wrappers_pb2.UInt32Value | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["height", b"height", "width", b"width"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["height", b"height", "width", b"width"]) -> None: ...

global___Dimensions = Dimensions

@typing.final
class WidgetStyles(google.protobuf.message.Message):
    """WidgetStyles represents the widget's panel appearance."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    HIDE_TITLE_FIELD_NUMBER: builtins.int
    BACKGROUND_COLOR_FIELD_NUMBER: builtins.int
    HIDE_HORIZONTAL_BAR_FIELD_NUMBER: builtins.int
    TITLE_SIZE_FIELD_NUMBER: builtins.int
    @property
    def hide_title(self) -> google.protobuf.wrappers_pb2.BoolValue:
        """hide_title is used to hint the dashboard that the widget title must be hidden."""

    @property
    def background_color(self) -> google.protobuf.wrappers_pb2.StringValue:
        """background_color is used to set the widget's background color."""

    @property
    def hide_horizontal_bar(self) -> google.protobuf.wrappers_pb2.BoolValue:
        """hide_horizontal_bar is used to hint the dashboard that the title separator must be hidden."""

    @property
    def title_size(self) -> google.protobuf.wrappers_pb2.UInt32Value:
        """title_size is used to set widget's title size."""

    def __init__(
        self,
        *,
        hide_title: google.protobuf.wrappers_pb2.BoolValue | None = ...,
        background_color: google.protobuf.wrappers_pb2.StringValue | None = ...,
        hide_horizontal_bar: google.protobuf.wrappers_pb2.BoolValue | None = ...,
        title_size: google.protobuf.wrappers_pb2.UInt32Value | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["background_color", b"background_color", "hide_horizontal_bar", b"hide_horizontal_bar", "hide_title", b"hide_title", "title_size", b"title_size"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["background_color", b"background_color", "hide_horizontal_bar", b"hide_horizontal_bar", "hide_title", b"hide_title", "title_size", b"title_size"]) -> None: ...

global___WidgetStyles = WidgetStyles

@typing.final
class Widget(google.protobuf.message.Message):
    """Widget is used to create a dashboard.
    Each widget is responsible to display some type of data.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ID_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    POSITION_FIELD_NUMBER: builtins.int
    DIMENSIONS_FIELD_NUMBER: builtins.int
    TYPE_FIELD_NUMBER: builtins.int
    INPUTS_FIELD_NUMBER: builtins.int
    LOCATION_FIELD_NUMBER: builtins.int
    STYLES_FIELD_NUMBER: builtins.int
    PARENT_FIELD_NUMBER: builtins.int
    @property
    def id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """id holds the unique identifier for the widget inside a dashboard"""

    @property
    def name(self) -> google.protobuf.wrappers_pb2.StringValue:
        """name of the widget is displayed at the top of the widget."""

    @property
    def position(self) -> global___Position:
        """position of the widget, represented as a (x,y) coordinate in a grid.
        Top left is at (0,0).
        """

    @property
    def dimensions(self) -> global___Dimensions:
        """dimensions of the widget represents how many cell in the grid it takes."""

    @property
    def type(self) -> google.protobuf.wrappers_pb2.StringValue:
        """type is the widget type. Each type is handled differently in the UI,
        and can use different `inputs`.
        """

    @property
    def inputs(self) -> google.protobuf.wrappers_pb2.StringValue:
        """inputs contains metadata about the data the widget will display, encoded in a JSON string.
        Internal data vary based on the widget type `type` and is managed by the client.
        """

    @property
    def location(self) -> google.protobuf.wrappers_pb2.StringValue:
        """location is used as a position display hint, used and managed by the UI."""

    @property
    def styles(self) -> global___WidgetStyles:
        """styles represents the widget's panel appearance."""

    @property
    def parent(self) -> google.protobuf.wrappers_pb2.StringValue:
        """parent stores the id of its parent widget."""

    def __init__(
        self,
        *,
        id: google.protobuf.wrappers_pb2.StringValue | None = ...,
        name: google.protobuf.wrappers_pb2.StringValue | None = ...,
        position: global___Position | None = ...,
        dimensions: global___Dimensions | None = ...,
        type: google.protobuf.wrappers_pb2.StringValue | None = ...,
        inputs: google.protobuf.wrappers_pb2.StringValue | None = ...,
        location: google.protobuf.wrappers_pb2.StringValue | None = ...,
        styles: global___WidgetStyles | None = ...,
        parent: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["dimensions", b"dimensions", "id", b"id", "inputs", b"inputs", "location", b"location", "name", b"name", "parent", b"parent", "position", b"position", "styles", b"styles", "type", b"type"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["dimensions", b"dimensions", "id", b"id", "inputs", b"inputs", "location", b"location", "name", b"name", "parent", b"parent", "position", b"position", "styles", b"styles", "type", b"type"]) -> None: ...

global___Widget = Widget

@typing.final
class Widgets(google.protobuf.message.Message):
    """Widgets holds a list of `Widget`s."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUES_FIELD_NUMBER: builtins.int
    @property
    def values(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Widget]:
        """values holds a list of widgets"""

    def __init__(
        self,
        *,
        values: collections.abc.Iterable[global___Widget] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["values", b"values"]) -> None: ...

global___Widgets = Widgets

@typing.final
class DashboardKey(google.protobuf.message.Message):
    """DashboardKey represents the dashboard unique identifier."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    DASHBOARD_ID_FIELD_NUMBER: builtins.int
    @property
    def dashboard_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """dashboard_id holds the id of the dashboard"""

    def __init__(
        self,
        *,
        dashboard_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["dashboard_id", b"dashboard_id"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["dashboard_id", b"dashboard_id"]) -> None: ...

global___DashboardKey = DashboardKey

@typing.final
class DashboardConfig(google.protobuf.message.Message):
    """DashboardConfig includes all user-editable dashboard fields."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    WIDGETS_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> global___DashboardKey:
        """key is the unique identifier. It always must be defined.
        If set, will create or update a dashboard.
        """

    @property
    def name(self) -> google.protobuf.wrappers_pb2.StringValue:
        """name is the dashboard name, displayed at the top of the dashboard."""

    @property
    def description(self) -> google.protobuf.wrappers_pb2.StringValue:
        """description may include details about what is displayed in the dashboard."""

    @property
    def widgets(self) -> global___Widgets:
        """widgets list of widgets in the dashboard."""

    def __init__(
        self,
        *,
        key: global___DashboardKey | None = ...,
        name: google.protobuf.wrappers_pb2.StringValue | None = ...,
        description: google.protobuf.wrappers_pb2.StringValue | None = ...,
        widgets: global___Widgets | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["description", b"description", "key", b"key", "name", b"name", "widgets", b"widgets"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["description", b"description", "key", b"key", "name", b"name", "widgets", b"widgets"]) -> None: ...

global___DashboardConfig = DashboardConfig

@typing.final
class DashboardMetadata(google.protobuf.message.Message):
    """DashboardMetadata includes versioning metadata. All the data here is managed internally, and
    is read-only.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SCHEMA_VERSION_FIELD_NUMBER: builtins.int
    LEGACY_KEY_FIELD_NUMBER: builtins.int
    LEGACY_VERSION_FIELD_NUMBER: builtins.int
    FROM_PACKAGE_FIELD_NUMBER: builtins.int
    @property
    def schema_version(self) -> google.protobuf.wrappers_pb2.StringValue:
        """schema_version is managed internally."""

    @property
    def legacy_key(self) -> google.protobuf.wrappers_pb2.StringValue:
        """legacy_key holds the key of a previous version of the dashboard, in case it was migrated."""

    @property
    def legacy_version(self) -> google.protobuf.wrappers_pb2.StringValue:
        """legacy_version tells from which version the dashboard was migrated from."""

    @property
    def from_package(self) -> google.protobuf.wrappers_pb2.StringValue:
        """from_package records the contributing package key and version, if applicable."""

    def __init__(
        self,
        *,
        schema_version: google.protobuf.wrappers_pb2.StringValue | None = ...,
        legacy_key: google.protobuf.wrappers_pb2.StringValue | None = ...,
        legacy_version: google.protobuf.wrappers_pb2.StringValue | None = ...,
        from_package: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["from_package", b"from_package", "legacy_key", b"legacy_key", "legacy_version", b"legacy_version", "schema_version", b"schema_version"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["from_package", b"from_package", "legacy_key", b"legacy_key", "legacy_version", b"legacy_version", "schema_version", b"schema_version"]) -> None: ...

global___DashboardMetadata = DashboardMetadata

@typing.final
class Filter(google.protobuf.message.Message):
    """Filter is used to filter dashboards for non exact match cases."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TAGS_FIELD_NUMBER: builtins.int
    @property
    def tags(self) -> fmp.wrappers_pb2.RepeatedString:
        """tags includes the values to be matched in the dashboard description.
        Tags are matched by word. Generally, a tag is prefixed by a '#',
        which must be omitted when provided here.
        All provided tags must match inside a dashboard for it to be returned.
        E.g., to match "#devices", the tag should be set to "devices".
        """

    def __init__(
        self,
        *,
        tags: fmp.wrappers_pb2.RepeatedString | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["tags", b"tags"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["tags", b"tags"]) -> None: ...

global___Filter = Filter

@typing.final
class Dashboard(google.protobuf.message.Message):
    """Dashboard state contains all dashboard data."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    CREATED_AT_FIELD_NUMBER: builtins.int
    CREATED_BY_FIELD_NUMBER: builtins.int
    LAST_MODIFIED_AT_FIELD_NUMBER: builtins.int
    LAST_MODIFIED_BY_FIELD_NUMBER: builtins.int
    META_DATA_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    WIDGETS_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> global___DashboardKey:
        """key is the unique identifier. It will always be defined."""

    @property
    def created_at(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """created_at represents the date the dashboard was first created.
        Old dashboards may not have this field set.
        """

    @property
    def created_by(self) -> google.protobuf.wrappers_pb2.StringValue:
        """created_by keeps the name of the user who first created this dashboard.
        Old dashboards may not have this field set.
        """

    @property
    def last_modified_at(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """last_modified_at holds the timestamp this dashboard was last updated by an user.
        Old dashboards may not have this field set.
        """

    @property
    def last_modified_by(self) -> google.protobuf.wrappers_pb2.StringValue:
        """last_modified_by holds the username who last updated this dashboard.
        Old dashboards may not have this field set.
        """

    @property
    def meta_data(self) -> global___DashboardMetadata:
        """meta_data includes version metadata about the dashboard."""

    @property
    def name(self) -> google.protobuf.wrappers_pb2.StringValue:
        """name is the dashboard name, displayed at the top of the dashboard."""

    @property
    def description(self) -> google.protobuf.wrappers_pb2.StringValue:
        """description may include details about what is displayed in the dashboard."""

    @property
    def widgets(self) -> global___Widgets:
        """widgets list of widgets in the dashboard."""

    def __init__(
        self,
        *,
        key: global___DashboardKey | None = ...,
        created_at: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        created_by: google.protobuf.wrappers_pb2.StringValue | None = ...,
        last_modified_at: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        last_modified_by: google.protobuf.wrappers_pb2.StringValue | None = ...,
        meta_data: global___DashboardMetadata | None = ...,
        name: google.protobuf.wrappers_pb2.StringValue | None = ...,
        description: google.protobuf.wrappers_pb2.StringValue | None = ...,
        widgets: global___Widgets | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["created_at", b"created_at", "created_by", b"created_by", "description", b"description", "key", b"key", "last_modified_at", b"last_modified_at", "last_modified_by", b"last_modified_by", "meta_data", b"meta_data", "name", b"name", "widgets", b"widgets"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["created_at", b"created_at", "created_by", b"created_by", "description", b"description", "key", b"key", "last_modified_at", b"last_modified_at", "last_modified_by", b"last_modified_by", "meta_data", b"meta_data", "name", b"name", "widgets", b"widgets"]) -> None: ...

global___Dashboard = Dashboard

@typing.final
class GlobalDashboardConfig(google.protobuf.message.Message):
    """GlobalDashboardConfig holds global configs related to Dashboards."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    DEFAULT_DASHBOARD_FIELD_NUMBER: builtins.int
    @property
    def default_dashboard(self) -> global___DashboardKey:
        """default_dashboard is the default dashboard shown to a user.
        To unset, use an empty key (`{dashboard_id: nil}`) in a `Set()` call.
        """

    def __init__(
        self,
        *,
        default_dashboard: global___DashboardKey | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["default_dashboard", b"default_dashboard"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["default_dashboard", b"default_dashboard"]) -> None: ...

global___GlobalDashboardConfig = GlobalDashboardConfig
