"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Copyright (c) 2023 Arista Networks, Inc.  All rights reserved.
Use of this source code is governed by the Apache License 2.0
that can be found in the COPYING file.
"""

import builtins
import collections.abc
import fmp.wrappers_pb2
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import google.protobuf.timestamp_pb2
import google.protobuf.wrappers_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _MacType:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _MacTypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_MacType.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    MAC_TYPE_UNSPECIFIED: _MacType.ValueType  # 0
    """MAC_TYPE_UNSPECIFIED is the default unspecified MAC type."""
    MAC_TYPE_LEARNED_DYNAMIC: _MacType.ValueType  # 1
    """MAC_TYPE_LEARNED_DYNAMIC indicates a MAC that is dynamically learned in hardware."""
    MAC_TYPE_LEARNED_SECURE: _MacType.ValueType  # 2
    """MAC_TYPE_LEARNED_SECURE indicates a MAC that is learned in hardware on a port-security protect interface."""
    MAC_TYPE_CONFIGURED_DYNAMIC: _MacType.ValueType  # 3
    """MAC_TYPE_CONFIGURED_DYNAMIC indicates a configured dynamic MAC."""
    MAC_TYPE_CONFIGURED_SECURE: _MacType.ValueType  # 4
    """MAC_TYPE_CONFIGURED_SECURE indicates a MAC configured on an interface with Port Security: Protect mode enabled"""
    MAC_TYPE_CONFIGURED_STATIC: _MacType.ValueType  # 5
    """MAC_TYPE_CONFIGURED_STATIC indicates a statically configured MAC."""
    MAC_TYPE_PEER_DYNAMIC: _MacType.ValueType  # 6
    """MAC_TYPE_PEER_DYNAMIC indicates a dynamically learned MAC discovered via an MLAG peer."""
    MAC_TYPE_PEER_STATIC: _MacType.ValueType  # 7
    """MAC_TYPE_PEER_STATIC indicates a statically configured MAC discovered via an MLAG peer."""
    MAC_TYPE_PEER_SECURE: _MacType.ValueType  # 8
    """MAC_TYPE_PEER_SECURE indicates a secure MAC learned from an MLAG peer."""
    MAC_TYPE_LEARNED_REMOTE: _MacType.ValueType  # 9
    """MAC_TYPE_LEARNED_REMOTE indicates a MAC learned remotely behind a VxLAN VTEP."""
    MAC_TYPE_CONFIGURED_REMOTE: _MacType.ValueType  # 10
    """MAC_TYPE_CONFIGURED_REMOTE indicates a MAC configured behind a VxLAN VTEP."""
    MAC_TYPE_RECEIVED_REMOTE: _MacType.ValueType  # 11
    """MAC_TYPE_RECEIVED_REMOTE indicates a MAC received from a VxLAN controller."""
    MAC_TYPE_PEER_LEARNED_REMOTE: _MacType.ValueType  # 12
    """MAC_TYPE_PEER_LEARNED_REMOTE indicates a remote MAC learned on a peer VTEP."""
    MAC_TYPE_PEER_CONFIGURED_REMOTE: _MacType.ValueType  # 13
    """MAC_TYPE_PEER_CONFIGURED_REMOTE indicates an MLAG peer configured remote MAC."""
    MAC_TYPE_PEER_RECEIVED_REMOTE: _MacType.ValueType  # 14
    """MAC_TYPE_PEER_RECEIVED_REMOTE indicates a remote MAC received from a VxLAN controller by the MLAG peer."""
    MAC_TYPE_EVPN_DYNAMIC_REMOTE: _MacType.ValueType  # 15
    """MAC_TYPE_EVPN_DYNAMIC_REMOTE indicates an EVPN dynamic remote MAC."""
    MAC_TYPE_EVPN_CONFIGURED_REMOTE: _MacType.ValueType  # 16
    """MAC_TYPE_EVPN_CONFIGURED_REMOTE indicates an EVPN configured remote MAC."""
    MAC_TYPE_PEER_EVPN_REMOTE: _MacType.ValueType  # 17
    """MAC_TYPE_PEER_EVPN_REMOTE indicates an MLAG peer EVPN remote MAC."""
    MAC_TYPE_CONFIGURED_ROUTER: _MacType.ValueType  # 18
    """MAC_TYPE_CONFIGURED_ROUTER indicates a configured MAC used in routing."""
    MAC_TYPE_PEER_ROUTER: _MacType.ValueType  # 19
    """MAC_TYPE_PEER_ROUTER indicates an MLAG peer specific router MAC."""
    MAC_TYPE_EVPN_INTF_DYNAMIC: _MacType.ValueType  # 20
    """MAC_TYPE_EVPN_INTF_DYNAMIC indicates a MAC advertised by EVPN when a dynamic MAC is learned on ESI (Ethernet Segment Identifier)."""
    MAC_TYPE_EVPN_INTF_STATIC: _MacType.ValueType  # 21
    """MAC_TYPE_EVPN_INTF_STATIC indicates a MAC configured on EVPN ESI."""
    MAC_TYPE_AUTHENTICATED: _MacType.ValueType  # 22
    """MAC_TYPE_AUTHENTICATED indicates a MAC authenticated via 802.1X."""
    MAC_TYPE_PEER_AUTHENTICATED: _MacType.ValueType  # 23
    """MAC_TYPE_PEER_AUTHENTICATED indicates a MAC authenticated by 802.1X and learned on an MLAG peer."""
    MAC_TYPE_PENDING_SECURE: _MacType.ValueType  # 24
    """MAC_TYPE_PENDING_SECURE indicates a secure MAC in a pending state."""
    MAC_TYPE_SOFTWARE_LEARNED_DYNAMIC: _MacType.ValueType  # 25
    """MAC_TYPE_SOFTWARE_LEARNED_DYNAMIC indicates a MAC learned behind VTEP in software in the case of a VxLAN remote MAC."""
    MAC_TYPE_OTHER: _MacType.ValueType  # 99999
    """MAC_TYPE_OTHER is used for capturing future MAC types."""

class MacType(_MacType, metaclass=_MacTypeEnumTypeWrapper):
    """MacType describes how the MAC address was learned on the port location."""

MAC_TYPE_UNSPECIFIED: MacType.ValueType  # 0
"""MAC_TYPE_UNSPECIFIED is the default unspecified MAC type."""
MAC_TYPE_LEARNED_DYNAMIC: MacType.ValueType  # 1
"""MAC_TYPE_LEARNED_DYNAMIC indicates a MAC that is dynamically learned in hardware."""
MAC_TYPE_LEARNED_SECURE: MacType.ValueType  # 2
"""MAC_TYPE_LEARNED_SECURE indicates a MAC that is learned in hardware on a port-security protect interface."""
MAC_TYPE_CONFIGURED_DYNAMIC: MacType.ValueType  # 3
"""MAC_TYPE_CONFIGURED_DYNAMIC indicates a configured dynamic MAC."""
MAC_TYPE_CONFIGURED_SECURE: MacType.ValueType  # 4
"""MAC_TYPE_CONFIGURED_SECURE indicates a MAC configured on an interface with Port Security: Protect mode enabled"""
MAC_TYPE_CONFIGURED_STATIC: MacType.ValueType  # 5
"""MAC_TYPE_CONFIGURED_STATIC indicates a statically configured MAC."""
MAC_TYPE_PEER_DYNAMIC: MacType.ValueType  # 6
"""MAC_TYPE_PEER_DYNAMIC indicates a dynamically learned MAC discovered via an MLAG peer."""
MAC_TYPE_PEER_STATIC: MacType.ValueType  # 7
"""MAC_TYPE_PEER_STATIC indicates a statically configured MAC discovered via an MLAG peer."""
MAC_TYPE_PEER_SECURE: MacType.ValueType  # 8
"""MAC_TYPE_PEER_SECURE indicates a secure MAC learned from an MLAG peer."""
MAC_TYPE_LEARNED_REMOTE: MacType.ValueType  # 9
"""MAC_TYPE_LEARNED_REMOTE indicates a MAC learned remotely behind a VxLAN VTEP."""
MAC_TYPE_CONFIGURED_REMOTE: MacType.ValueType  # 10
"""MAC_TYPE_CONFIGURED_REMOTE indicates a MAC configured behind a VxLAN VTEP."""
MAC_TYPE_RECEIVED_REMOTE: MacType.ValueType  # 11
"""MAC_TYPE_RECEIVED_REMOTE indicates a MAC received from a VxLAN controller."""
MAC_TYPE_PEER_LEARNED_REMOTE: MacType.ValueType  # 12
"""MAC_TYPE_PEER_LEARNED_REMOTE indicates a remote MAC learned on a peer VTEP."""
MAC_TYPE_PEER_CONFIGURED_REMOTE: MacType.ValueType  # 13
"""MAC_TYPE_PEER_CONFIGURED_REMOTE indicates an MLAG peer configured remote MAC."""
MAC_TYPE_PEER_RECEIVED_REMOTE: MacType.ValueType  # 14
"""MAC_TYPE_PEER_RECEIVED_REMOTE indicates a remote MAC received from a VxLAN controller by the MLAG peer."""
MAC_TYPE_EVPN_DYNAMIC_REMOTE: MacType.ValueType  # 15
"""MAC_TYPE_EVPN_DYNAMIC_REMOTE indicates an EVPN dynamic remote MAC."""
MAC_TYPE_EVPN_CONFIGURED_REMOTE: MacType.ValueType  # 16
"""MAC_TYPE_EVPN_CONFIGURED_REMOTE indicates an EVPN configured remote MAC."""
MAC_TYPE_PEER_EVPN_REMOTE: MacType.ValueType  # 17
"""MAC_TYPE_PEER_EVPN_REMOTE indicates an MLAG peer EVPN remote MAC."""
MAC_TYPE_CONFIGURED_ROUTER: MacType.ValueType  # 18
"""MAC_TYPE_CONFIGURED_ROUTER indicates a configured MAC used in routing."""
MAC_TYPE_PEER_ROUTER: MacType.ValueType  # 19
"""MAC_TYPE_PEER_ROUTER indicates an MLAG peer specific router MAC."""
MAC_TYPE_EVPN_INTF_DYNAMIC: MacType.ValueType  # 20
"""MAC_TYPE_EVPN_INTF_DYNAMIC indicates a MAC advertised by EVPN when a dynamic MAC is learned on ESI (Ethernet Segment Identifier)."""
MAC_TYPE_EVPN_INTF_STATIC: MacType.ValueType  # 21
"""MAC_TYPE_EVPN_INTF_STATIC indicates a MAC configured on EVPN ESI."""
MAC_TYPE_AUTHENTICATED: MacType.ValueType  # 22
"""MAC_TYPE_AUTHENTICATED indicates a MAC authenticated via 802.1X."""
MAC_TYPE_PEER_AUTHENTICATED: MacType.ValueType  # 23
"""MAC_TYPE_PEER_AUTHENTICATED indicates a MAC authenticated by 802.1X and learned on an MLAG peer."""
MAC_TYPE_PENDING_SECURE: MacType.ValueType  # 24
"""MAC_TYPE_PENDING_SECURE indicates a secure MAC in a pending state."""
MAC_TYPE_SOFTWARE_LEARNED_DYNAMIC: MacType.ValueType  # 25
"""MAC_TYPE_SOFTWARE_LEARNED_DYNAMIC indicates a MAC learned behind VTEP in software in the case of a VxLAN remote MAC."""
MAC_TYPE_OTHER: MacType.ValueType  # 99999
"""MAC_TYPE_OTHER is used for capturing future MAC types."""
global___MacType = MacType

class _Likelihood:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _LikelihoodEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_Likelihood.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    LIKELIHOOD_UNSPECIFIED: _Likelihood.ValueType  # 0
    """LIKELIHOOD_UNSPECIFIED is the default unspecified likelihood."""
    LIKELIHOOD_VERY_LIKELY: _Likelihood.ValueType  # 1
    """LIKELIHOOD_VERY_LIKELY indicates very high confidence."""
    LIKELIHOOD_LIKELY: _Likelihood.ValueType  # 2
    """LIKELIHOOD_LIKELY indicates high confidence."""
    LIKELIHOOD_SOMEWHAT_LIKELY: _Likelihood.ValueType  # 3
    """LIKELIHOOD_SOMEWHAT_LIKELY indicates medium confidence."""
    LIKELIHOOD_LESS_LIKELY: _Likelihood.ValueType  # 4
    """LIKELIHOOD_LESS_LIKELY indicates low confidence."""

class Likelihood(_Likelihood, metaclass=_LikelihoodEnumTypeWrapper):
    """Likelihood indicates a level of confidence."""

LIKELIHOOD_UNSPECIFIED: Likelihood.ValueType  # 0
"""LIKELIHOOD_UNSPECIFIED is the default unspecified likelihood."""
LIKELIHOOD_VERY_LIKELY: Likelihood.ValueType  # 1
"""LIKELIHOOD_VERY_LIKELY indicates very high confidence."""
LIKELIHOOD_LIKELY: Likelihood.ValueType  # 2
"""LIKELIHOOD_LIKELY indicates high confidence."""
LIKELIHOOD_SOMEWHAT_LIKELY: Likelihood.ValueType  # 3
"""LIKELIHOOD_SOMEWHAT_LIKELY indicates medium confidence."""
LIKELIHOOD_LESS_LIKELY: Likelihood.ValueType  # 4
"""LIKELIHOOD_LESS_LIKELY indicates low confidence."""
global___Likelihood = Likelihood

class _IdentifierType:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _IdentifierTypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_IdentifierType.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    IDENTIFIER_TYPE_UNSPECIFIED: _IdentifierType.ValueType  # 0
    """IDENTIFIER_TYPE_UNSPECIFIED is the default unspecified identifier."""
    IDENTIFIER_TYPE_MAC_ADDR: _IdentifierType.ValueType  # 1
    """IDENTIFIER_TYPE_MAC_ADDR indicates a MAC address identifier."""
    IDENTIFIER_TYPE_IPV4_ADDR: _IdentifierType.ValueType  # 2
    """IDENTIFIER_TYPE_IPV4_ADDR indicates an IPv4 address identifier."""
    IDENTIFIER_TYPE_IPV6_ADDR: _IdentifierType.ValueType  # 3
    """IDENTIFIER_TYPE_IPV6_ADDR indicates an IPv6 address identifier."""
    IDENTIFIER_TYPE_INVENTORY_DEVICE_ID: _IdentifierType.ValueType  # 4
    """IDENTIFIER_TYPE_INVENTORY_DEVICE_ID indicates an inventory device identifier."""
    IDENTIFIER_TYPE_PRIMARY_MANAGEMENT_IP: _IdentifierType.ValueType  # 5
    """IDENTIFIER_TYPE_PRIMARY_MANAGEMENT_IP indicates a primary management IP identifier."""
    IDENTIFIER_TYPE_HOSTNAME: _IdentifierType.ValueType  # 6
    """IDENTIFIER_TYPE_HOSTNAME indicates a hostname identifier."""
    IDENTIFIER_TYPE_USERNAME: _IdentifierType.ValueType  # 7
    """IDENTIFIER_TYPE_USERNAME indicates a username identifier.
    Deprecated - do not return usernames of wifi endpoints anymore
    """
    IDENTIFIER_TYPE_OTHER: _IdentifierType.ValueType  # 99999
    """IDENTIFIER_TYPE_OTHER is used for an unknown identifier."""

class IdentifierType(_IdentifierType, metaclass=_IdentifierTypeEnumTypeWrapper):
    """IdentifierType defines the set of ways for identifying endpoints."""

IDENTIFIER_TYPE_UNSPECIFIED: IdentifierType.ValueType  # 0
"""IDENTIFIER_TYPE_UNSPECIFIED is the default unspecified identifier."""
IDENTIFIER_TYPE_MAC_ADDR: IdentifierType.ValueType  # 1
"""IDENTIFIER_TYPE_MAC_ADDR indicates a MAC address identifier."""
IDENTIFIER_TYPE_IPV4_ADDR: IdentifierType.ValueType  # 2
"""IDENTIFIER_TYPE_IPV4_ADDR indicates an IPv4 address identifier."""
IDENTIFIER_TYPE_IPV6_ADDR: IdentifierType.ValueType  # 3
"""IDENTIFIER_TYPE_IPV6_ADDR indicates an IPv6 address identifier."""
IDENTIFIER_TYPE_INVENTORY_DEVICE_ID: IdentifierType.ValueType  # 4
"""IDENTIFIER_TYPE_INVENTORY_DEVICE_ID indicates an inventory device identifier."""
IDENTIFIER_TYPE_PRIMARY_MANAGEMENT_IP: IdentifierType.ValueType  # 5
"""IDENTIFIER_TYPE_PRIMARY_MANAGEMENT_IP indicates a primary management IP identifier."""
IDENTIFIER_TYPE_HOSTNAME: IdentifierType.ValueType  # 6
"""IDENTIFIER_TYPE_HOSTNAME indicates a hostname identifier."""
IDENTIFIER_TYPE_USERNAME: IdentifierType.ValueType  # 7
"""IDENTIFIER_TYPE_USERNAME indicates a username identifier.
Deprecated - do not return usernames of wifi endpoints anymore
"""
IDENTIFIER_TYPE_OTHER: IdentifierType.ValueType  # 99999
"""IDENTIFIER_TYPE_OTHER is used for an unknown identifier."""
global___IdentifierType = IdentifierType

class _IdentifierSource:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _IdentifierSourceEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_IdentifierSource.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    IDENTIFIER_SOURCE_UNSPECIFIED: _IdentifierSource.ValueType  # 0
    """IDENTIFIER_SOURCE_UNSPECIFIED is the default unspecified identifier source."""
    IDENTIFIER_SOURCE_FDB: _IdentifierSource.ValueType  # 1
    """IDENTIFIER_SOURCE_FDB indicates a forwarding table."""
    IDENTIFIER_SOURCE_ARP: _IdentifierSource.ValueType  # 2
    """IDENTIFIER_SOURCE_ARP indicates ARP (IPv4)."""
    IDENTIFIER_SOURCE_NEIGHBOR: _IdentifierSource.ValueType  # 3
    """IDENTIFIER_SOURCE_NEIGHBOR indicates NDP (IPv6)."""
    IDENTIFIER_SOURCE_DEVICE_INVENTORY: _IdentifierSource.ValueType  # 4
    """IDENTIFIER_SOURCE_DEVICE_INVENTORY indicates that an endpoint is in the
    CloudVision inventory.
    """
    IDENTIFIER_SOURCE_LLDP: _IdentifierSource.ValueType  # 5
    """IDENTIFIER_SOURCE_LLDP indicates LLDP."""
    IDENTIFIER_SOURCE_DHCP: _IdentifierSource.ValueType  # 6
    """IDENTIFIER_SOURCE_DHCP indicates DHCP."""
    IDENTIFIER_SOURCE_WIFI: _IdentifierSource.ValueType  # 7
    """IDENTIFIER_SOURCE_WIFI indicates a WiFi endpoint that was learned through
    a wireless manager.
    Deprecated - do not support searches for wifi endpoints anymore
    """

class IdentifierSource(_IdentifierSource, metaclass=_IdentifierSourceEnumTypeWrapper):
    """IdentifierSource defines the set of network protocols and other
    information sources where an identifier was found.
    """

IDENTIFIER_SOURCE_UNSPECIFIED: IdentifierSource.ValueType  # 0
"""IDENTIFIER_SOURCE_UNSPECIFIED is the default unspecified identifier source."""
IDENTIFIER_SOURCE_FDB: IdentifierSource.ValueType  # 1
"""IDENTIFIER_SOURCE_FDB indicates a forwarding table."""
IDENTIFIER_SOURCE_ARP: IdentifierSource.ValueType  # 2
"""IDENTIFIER_SOURCE_ARP indicates ARP (IPv4)."""
IDENTIFIER_SOURCE_NEIGHBOR: IdentifierSource.ValueType  # 3
"""IDENTIFIER_SOURCE_NEIGHBOR indicates NDP (IPv6)."""
IDENTIFIER_SOURCE_DEVICE_INVENTORY: IdentifierSource.ValueType  # 4
"""IDENTIFIER_SOURCE_DEVICE_INVENTORY indicates that an endpoint is in the
CloudVision inventory.
"""
IDENTIFIER_SOURCE_LLDP: IdentifierSource.ValueType  # 5
"""IDENTIFIER_SOURCE_LLDP indicates LLDP."""
IDENTIFIER_SOURCE_DHCP: IdentifierSource.ValueType  # 6
"""IDENTIFIER_SOURCE_DHCP indicates DHCP."""
IDENTIFIER_SOURCE_WIFI: IdentifierSource.ValueType  # 7
"""IDENTIFIER_SOURCE_WIFI indicates a WiFi endpoint that was learned through
a wireless manager.
Deprecated - do not support searches for wifi endpoints anymore
"""
global___IdentifierSource = IdentifierSource

class _Explanation:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _ExplanationEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_Explanation.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    EXPLANATION_UNSPECIFIED: _Explanation.ValueType  # 0
    """EXPLANATION_UNSPECIFIED is the default unspecified explanation."""
    EXPLANATION_DIRECT_CONNECTION: _Explanation.ValueType  # 1
    """EXPLANATION_DIRECT_CONNECTION indicates a direct connection to the queried
    endpoint device discovered via LLDP.
    """
    EXPLANATION_NON_INVENTORY_CONNECTION: _Explanation.ValueType  # 2
    """EXPLANATION_NON_INVENTORY_CONNECTION indicates a direct connection to at least
    one non-inventory device (likely discovered via LLDP).
    """
    EXPLANATION_NO_CONNECTION: _Explanation.ValueType  # 3
    """EXPLANATION_NO_CONNECTION indicates that a location has no direct connection to
    any known device.
    """
    EXPLANATION_INVENTORY_CONNECTION: _Explanation.ValueType  # 4
    """EXPLANATION_INVENTORY_CONNECTION indicates that all of a location's known connections
    are to devices in the inventory.
    """
    EXPLANATION_OWN_PORT_INVENTORY_DEVICE: _Explanation.ValueType  # 5
    """EXPLANATION_OWN_PORT_INVENTORY_DEVICE indicates a location on the queried inventory
    device itself.
    """
    EXPLANATION_DIRECT_CONNECTION_INVENTORY_DEVICE: _Explanation.ValueType  # 6
    """EXPLANATION_DIRECT_CONNECTION_INVENTORY_DEVICE indicates a direct connection to the
    queried inventory device discovered via LLDP.
    """
    EXPLANATION_NO_CONNECTION_INVENTORY_DEVICE: _Explanation.ValueType  # 7
    """EXPLANATION_NO_CONNECTION_INVENTORY_DEVICE indicates that a location has no direct
    connection to any known device (for queried inventory devices).
    """
    EXPLANATION_OTHER_CONNECTION_INVENTORY_DEVICE: _Explanation.ValueType  # 8
    """EXPLANATION_OTHER_CONNECTION_INVENTORY_DEVICE indicates that a location only has
    connections to other devices besides the queried inventory device.
    """
    EXPLANATION_VIRTUAL: _Explanation.ValueType  # 9
    """EXPLANATION_VIRTUAL indicates that a location contains a virtual interface."""
    EXPLANATION_WIRELESS_CONNECTION: _Explanation.ValueType  # 10
    """EXPLANATION_WIRELESS_CONNECTION indicates a direct connection from a wireless access
    point in the device inventory to a wireless client.
    """
    EXPLANATION_ACCESS_PORT: _Explanation.ValueType  # 11
    """EXPLANATION_ACCESS_PORT indicates that a location is an access port."""

class Explanation(_Explanation, metaclass=_ExplanationEnumTypeWrapper):
    """Explanation defines the set of reasons for why a location has a certain likelihood.
    Some explanations apply to queried endpoints while others apply to queried devices
    in the CloudVision device inventory.
    """

EXPLANATION_UNSPECIFIED: Explanation.ValueType  # 0
"""EXPLANATION_UNSPECIFIED is the default unspecified explanation."""
EXPLANATION_DIRECT_CONNECTION: Explanation.ValueType  # 1
"""EXPLANATION_DIRECT_CONNECTION indicates a direct connection to the queried
endpoint device discovered via LLDP.
"""
EXPLANATION_NON_INVENTORY_CONNECTION: Explanation.ValueType  # 2
"""EXPLANATION_NON_INVENTORY_CONNECTION indicates a direct connection to at least
one non-inventory device (likely discovered via LLDP).
"""
EXPLANATION_NO_CONNECTION: Explanation.ValueType  # 3
"""EXPLANATION_NO_CONNECTION indicates that a location has no direct connection to
any known device.
"""
EXPLANATION_INVENTORY_CONNECTION: Explanation.ValueType  # 4
"""EXPLANATION_INVENTORY_CONNECTION indicates that all of a location's known connections
are to devices in the inventory.
"""
EXPLANATION_OWN_PORT_INVENTORY_DEVICE: Explanation.ValueType  # 5
"""EXPLANATION_OWN_PORT_INVENTORY_DEVICE indicates a location on the queried inventory
device itself.
"""
EXPLANATION_DIRECT_CONNECTION_INVENTORY_DEVICE: Explanation.ValueType  # 6
"""EXPLANATION_DIRECT_CONNECTION_INVENTORY_DEVICE indicates a direct connection to the
queried inventory device discovered via LLDP.
"""
EXPLANATION_NO_CONNECTION_INVENTORY_DEVICE: Explanation.ValueType  # 7
"""EXPLANATION_NO_CONNECTION_INVENTORY_DEVICE indicates that a location has no direct
connection to any known device (for queried inventory devices).
"""
EXPLANATION_OTHER_CONNECTION_INVENTORY_DEVICE: Explanation.ValueType  # 8
"""EXPLANATION_OTHER_CONNECTION_INVENTORY_DEVICE indicates that a location only has
connections to other devices besides the queried inventory device.
"""
EXPLANATION_VIRTUAL: Explanation.ValueType  # 9
"""EXPLANATION_VIRTUAL indicates that a location contains a virtual interface."""
EXPLANATION_WIRELESS_CONNECTION: Explanation.ValueType  # 10
"""EXPLANATION_WIRELESS_CONNECTION indicates a direct connection from a wireless access
point in the device inventory to a wireless client.
"""
EXPLANATION_ACCESS_PORT: Explanation.ValueType  # 11
"""EXPLANATION_ACCESS_PORT indicates that a location is an access port."""
global___Explanation = Explanation

class _DeviceType:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _DeviceTypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_DeviceType.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    DEVICE_TYPE_UNSPECIFIED: _DeviceType.ValueType  # 0
    """DEVICE_TYPE_UNSPECIFIED is the default unspecified device type."""
    DEVICE_TYPE_INVENTORY: _DeviceType.ValueType  # 1
    """DEVICE_TYPE_INVENTORY indicates a device in the CloudVision inventory."""
    DEVICE_TYPE_ENDPOINT: _DeviceType.ValueType  # 2
    """DEVICE_TYPE_ENDPOINT indicates an endpoint that does not exist
    in the CloudVision inventory.
    """
    DEVICE_TYPE_WIFI_ENDPOINT: _DeviceType.ValueType  # 3
    """DEVICE_TYPE_WIFI_ENDPOINT indicates a WiFi client/endpoint that does not
    exist in the CloudVision inventory.
    Deprecated - do not support searches for wifi endpoints anymore
    """

class DeviceType(_DeviceType, metaclass=_DeviceTypeEnumTypeWrapper):
    """DeviceType defines a broad set of categories for
    all queried devices.
    """

DEVICE_TYPE_UNSPECIFIED: DeviceType.ValueType  # 0
"""DEVICE_TYPE_UNSPECIFIED is the default unspecified device type."""
DEVICE_TYPE_INVENTORY: DeviceType.ValueType  # 1
"""DEVICE_TYPE_INVENTORY indicates a device in the CloudVision inventory."""
DEVICE_TYPE_ENDPOINT: DeviceType.ValueType  # 2
"""DEVICE_TYPE_ENDPOINT indicates an endpoint that does not exist
in the CloudVision inventory.
"""
DEVICE_TYPE_WIFI_ENDPOINT: DeviceType.ValueType  # 3
"""DEVICE_TYPE_WIFI_ENDPOINT indicates a WiFi client/endpoint that does not
exist in the CloudVision inventory.
Deprecated - do not support searches for wifi endpoints anymore
"""
global___DeviceType = DeviceType

class _DeviceStatus:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _DeviceStatusEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_DeviceStatus.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    DEVICE_STATUS_UNSPECIFIED: _DeviceStatus.ValueType  # 0
    """DEVICE_STATUS_UNSPECIFIED is the default unspecified device status."""
    DEVICE_STATUS_ACTIVE: _DeviceStatus.ValueType  # 1
    """DEVICE_STATUS_ACTIVE indicates a device is streaming its telemetry data
    to CloudVision.
    """
    DEVICE_STATUS_INACTIVE: _DeviceStatus.ValueType  # 2
    """DEVICE_STATUS_INACTIVE indicates a device is either not streaming its
    telemetry data to CloudVision or has been decommissioned from CloudVision.
    """

class DeviceStatus(_DeviceStatus, metaclass=_DeviceStatusEnumTypeWrapper):
    """DeviceStatus is the network status of a device."""

DEVICE_STATUS_UNSPECIFIED: DeviceStatus.ValueType  # 0
"""DEVICE_STATUS_UNSPECIFIED is the default unspecified device status."""
DEVICE_STATUS_ACTIVE: DeviceStatus.ValueType  # 1
"""DEVICE_STATUS_ACTIVE indicates a device is streaming its telemetry data
to CloudVision.
"""
DEVICE_STATUS_INACTIVE: DeviceStatus.ValueType  # 2
"""DEVICE_STATUS_INACTIVE indicates a device is either not streaming its
telemetry data to CloudVision or has been decommissioned from CloudVision.
"""
global___DeviceStatus = DeviceStatus

@typing.final
class IdentifierSourceList(google.protobuf.message.Message):
    """IdentifierSourceList is a list of IdentifierSource."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUES_FIELD_NUMBER: builtins.int
    @property
    def values(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[global___IdentifierSource.ValueType]:
        """values is an unordered list of unique IdentifierSource."""

    def __init__(
        self,
        *,
        values: collections.abc.Iterable[global___IdentifierSource.ValueType] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["values", b"values"]) -> None: ...

global___IdentifierSourceList = IdentifierSourceList

@typing.final
class Identifier(google.protobuf.message.Message):
    """Identifier holds device identification information."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TYPE_FIELD_NUMBER: builtins.int
    VALUE_FIELD_NUMBER: builtins.int
    SOURCE_LIST_FIELD_NUMBER: builtins.int
    type: global___IdentifierType.ValueType
    """type is the identifier type corresponding to value."""
    @property
    def value(self) -> google.protobuf.wrappers_pb2.StringValue:
        """value is the string representation of the identifier. Its interpretation
        depends on type.
        """

    @property
    def source_list(self) -> global___IdentifierSourceList:
        """source_list is the set of sources where this identifier was discovered."""

    def __init__(
        self,
        *,
        type: global___IdentifierType.ValueType = ...,
        value: google.protobuf.wrappers_pb2.StringValue | None = ...,
        source_list: global___IdentifierSourceList | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["source_list", b"source_list", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["source_list", b"source_list", "type", b"type", "value", b"value"]) -> None: ...

global___Identifier = Identifier

@typing.final
class IdentifierList(google.protobuf.message.Message):
    """IdentifierList is a list of Identifier."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUES_FIELD_NUMBER: builtins.int
    @property
    def values(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Identifier]:
        """values is an unordered list of Identifier where each Identifier has a
        unique type and value combination.
        """

    def __init__(
        self,
        *,
        values: collections.abc.Iterable[global___Identifier] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["values", b"values"]) -> None: ...

global___IdentifierList = IdentifierList

@typing.final
class ExplanationList(google.protobuf.message.Message):
    """ExplanationList is a list of Explanation."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUES_FIELD_NUMBER: builtins.int
    @property
    def values(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[global___Explanation.ValueType]:
        """values is a list of unique Explanation. Currently, this will
        always contain one value, but in the future it may contain
        more.
        """

    def __init__(
        self,
        *,
        values: collections.abc.Iterable[global___Explanation.ValueType] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["values", b"values"]) -> None: ...

global___ExplanationList = ExplanationList

@typing.final
class Location(google.protobuf.message.Message):
    """Location is a port (device_id, interface, vlan_id) on which
    at least one identifier has been discovered.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    DEVICE_ID_FIELD_NUMBER: builtins.int
    DEVICE_STATUS_FIELD_NUMBER: builtins.int
    INTERFACE_FIELD_NUMBER: builtins.int
    VLAN_ID_FIELD_NUMBER: builtins.int
    LEARNED_TIME_FIELD_NUMBER: builtins.int
    MAC_TYPE_FIELD_NUMBER: builtins.int
    LIKELIHOOD_FIELD_NUMBER: builtins.int
    EXPLANATION_LIST_FIELD_NUMBER: builtins.int
    IDENTIFIER_LIST_FIELD_NUMBER: builtins.int
    device_status: global___DeviceStatus.ValueType
    """device_status is the status of the device identified by device_id."""
    mac_type: global___MacType.ValueType
    """mac_type is how the port learned its MAC address identifier."""
    likelihood: global___Likelihood.ValueType
    """likelihood is the probability level that the port is directly connected
    to the queried endpoint.
    """
    @property
    def device_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """device_id identifies the device of the port."""

    @property
    def interface(self) -> google.protobuf.wrappers_pb2.StringValue:
        """interface is the interface of the port."""

    @property
    def vlan_id(self) -> google.protobuf.wrappers_pb2.UInt32Value:
        """vlan_id identifies the VLAN of the port."""

    @property
    def learned_time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """learned_time is when the port learned its identifiers."""

    @property
    def explanation_list(self) -> global___ExplanationList:
        """explanation_list holds the reasons that the port was assigned likelihood."""

    @property
    def identifier_list(self) -> global___IdentifierList:
        """identifier_list holds the discovered identifiers of the port."""

    def __init__(
        self,
        *,
        device_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
        device_status: global___DeviceStatus.ValueType = ...,
        interface: google.protobuf.wrappers_pb2.StringValue | None = ...,
        vlan_id: google.protobuf.wrappers_pb2.UInt32Value | None = ...,
        learned_time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        mac_type: global___MacType.ValueType = ...,
        likelihood: global___Likelihood.ValueType = ...,
        explanation_list: global___ExplanationList | None = ...,
        identifier_list: global___IdentifierList | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["device_id", b"device_id", "explanation_list", b"explanation_list", "identifier_list", b"identifier_list", "interface", b"interface", "learned_time", b"learned_time", "vlan_id", b"vlan_id"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["device_id", b"device_id", "device_status", b"device_status", "explanation_list", b"explanation_list", "identifier_list", b"identifier_list", "interface", b"interface", "learned_time", b"learned_time", "likelihood", b"likelihood", "mac_type", b"mac_type", "vlan_id", b"vlan_id"]) -> None: ...

global___Location = Location

@typing.final
class LocationList(google.protobuf.message.Message):
    """LocationList is a list of Location."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUES_FIELD_NUMBER: builtins.int
    @property
    def values(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Location]:
        """values is a list of unique Location."""

    def __init__(
        self,
        *,
        values: collections.abc.Iterable[global___Location] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["values", b"values"]) -> None: ...

global___LocationList = LocationList

@typing.final
class DeviceInfo(google.protobuf.message.Message):
    """DeviceInfo holds various attributes of a device (typically an endpoint) from Fingerbank."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    DEVICE_NAME_FIELD_NUMBER: builtins.int
    MOBILE_FIELD_NUMBER: builtins.int
    TABLET_FIELD_NUMBER: builtins.int
    SCORE_FIELD_NUMBER: builtins.int
    VERSION_FIELD_NUMBER: builtins.int
    MAC_VENDOR_FIELD_NUMBER: builtins.int
    CLASSIFICATION_FIELD_NUMBER: builtins.int
    HIERARCHY_FIELD_NUMBER: builtins.int
    @property
    def device_name(self) -> google.protobuf.wrappers_pb2.StringValue:
        """device_name is the name of the device."""

    @property
    def mobile(self) -> google.protobuf.wrappers_pb2.BoolValue:
        """mobile indicates whether the device is a mobile."""

    @property
    def tablet(self) -> google.protobuf.wrappers_pb2.BoolValue:
        """tablet indicates whether the device is a tablet."""

    @property
    def score(self) -> google.protobuf.wrappers_pb2.UInt32Value:
        """score is a value from 0 to 100 that indicates how confident we are
        that the device has device_name.
        Fingerbank API documentation of score: https://api.fingerbank.org/api_doc/2/combinations.html
        """

    @property
    def version(self) -> google.protobuf.wrappers_pb2.StringValue:
        """version is the version of device_name."""

    @property
    def mac_vendor(self) -> google.protobuf.wrappers_pb2.StringValue:
        """mac_vendor is the enterprise that assigns the MAC address of the device."""

    @property
    def classification(self) -> google.protobuf.wrappers_pb2.StringValue:
        """classification is the broadest category to which device_name belongs.
        This is the highest level in hierarchy.
        """

    @property
    def hierarchy(self) -> fmp.wrappers_pb2.RepeatedString:
        """hierarchy is a list of categorizations of the device from most broad
        to most specific. The first element is always classification and the
        last element is always device_name.

        For example,

        ["VoIP Device", "FooInc VoIP", "FooInc PhoneSet IP", "FooInc PhoneSet IP Model123"]

        In this hierarchy, "VoIP Device" is classification and "FooInc PhoneSet IP Model123"
        is device_name.
        """

    def __init__(
        self,
        *,
        device_name: google.protobuf.wrappers_pb2.StringValue | None = ...,
        mobile: google.protobuf.wrappers_pb2.BoolValue | None = ...,
        tablet: google.protobuf.wrappers_pb2.BoolValue | None = ...,
        score: google.protobuf.wrappers_pb2.UInt32Value | None = ...,
        version: google.protobuf.wrappers_pb2.StringValue | None = ...,
        mac_vendor: google.protobuf.wrappers_pb2.StringValue | None = ...,
        classification: google.protobuf.wrappers_pb2.StringValue | None = ...,
        hierarchy: fmp.wrappers_pb2.RepeatedString | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["classification", b"classification", "device_name", b"device_name", "hierarchy", b"hierarchy", "mac_vendor", b"mac_vendor", "mobile", b"mobile", "score", b"score", "tablet", b"tablet", "version", b"version"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["classification", b"classification", "device_name", b"device_name", "hierarchy", b"hierarchy", "mac_vendor", b"mac_vendor", "mobile", b"mobile", "score", b"score", "tablet", b"tablet", "version", b"version"]) -> None: ...

global___DeviceInfo = DeviceInfo

@typing.final
class Device(google.protobuf.message.Message):
    """Device holds information for a device matching a search term."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    IDENTIFIER_LIST_FIELD_NUMBER: builtins.int
    DEVICE_TYPE_FIELD_NUMBER: builtins.int
    LOCATION_LIST_FIELD_NUMBER: builtins.int
    DEVICE_STATUS_FIELD_NUMBER: builtins.int
    DEVICE_INFO_FIELD_NUMBER: builtins.int
    device_type: global___DeviceType.ValueType
    """device_type is the broad category of the device."""
    device_status: global___DeviceStatus.ValueType
    """device_status is the network status of the device."""
    @property
    def identifier_list(self) -> global___IdentifierList:
        """identifier_list holds the unique identifiers for the device."""

    @property
    def location_list(self) -> global___LocationList:
        """location_list is the list of possible locations of the device.
        It is ordered from most likely to least likely.
        """

    @property
    def device_info(self) -> global___DeviceInfo:
        """device_info holds various attributes of the device."""

    def __init__(
        self,
        *,
        identifier_list: global___IdentifierList | None = ...,
        device_type: global___DeviceType.ValueType = ...,
        location_list: global___LocationList | None = ...,
        device_status: global___DeviceStatus.ValueType = ...,
        device_info: global___DeviceInfo | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["device_info", b"device_info", "identifier_list", b"identifier_list", "location_list", b"location_list"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["device_info", b"device_info", "device_status", b"device_status", "device_type", b"device_type", "identifier_list", b"identifier_list", "location_list", b"location_list"]) -> None: ...

global___Device = Device

@typing.final
class DeviceMap(google.protobuf.message.Message):
    """DeviceMap is a collection of Device."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class ValuesEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> global___Device: ...
        def __init__(
            self,
            *,
            key: builtins.str = ...,
            value: global___Device | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    VALUES_FIELD_NUMBER: builtins.int
    @property
    def values(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, global___Device]:
        """values is a map from most specific identifier to Device.
        The key could be device serial number or MAC address.
        """

    def __init__(
        self,
        *,
        values: collections.abc.Mapping[builtins.str, global___Device] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["values", b"values"]) -> None: ...

global___DeviceMap = DeviceMap

@typing.final
class EndpointLocationKey(google.protobuf.message.Message):
    """EndpointLocationKey holds a search term used to locate an endpoint."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SEARCH_TERM_FIELD_NUMBER: builtins.int
    @property
    def search_term(self) -> google.protobuf.wrappers_pb2.StringValue:
        """search_term is used to match against identifiers on devices.
        This could be a MAC/IP address, hostname, etc.
        """

    def __init__(
        self,
        *,
        search_term: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["search_term", b"search_term"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["search_term", b"search_term"]) -> None: ...

global___EndpointLocationKey = EndpointLocationKey

@typing.final
class EndpointLocation(google.protobuf.message.Message):
    """EndpointLocation is the entrypoint to searching for
    endpoints.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    DEVICE_MAP_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> global___EndpointLocationKey:
        """key holds a search term used to locate an endpoint."""

    @property
    def device_map(self) -> global___DeviceMap:
        """device_map holds the devices (and their potential locations)
        that match the search term.
        """

    def __init__(
        self,
        *,
        key: global___EndpointLocationKey | None = ...,
        device_map: global___DeviceMap | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["device_map", b"device_map", "key", b"key"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["device_map", b"device_map", "key", b"key"]) -> None: ...

global___EndpointLocation = EndpointLocation
