"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Copyright (c) 2023 Arista Networks, Inc.  All rights reserved.
Use of this source code is governed by the Apache License 2.0
that can be found in the COPYING file.
"""

import builtins
import fmp.wrappers_pb2
import google.protobuf.descriptor
import google.protobuf.message
import google.protobuf.timestamp_pb2
import google.protobuf.wrappers_pb2
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class DeviceLifecycleSummaryKey(google.protobuf.message.Message):
    """DeviceLifecycleSummaryKey is the key type for
    DeviceLifecycleSummary model
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    DEVICE_ID_FIELD_NUMBER: builtins.int
    @property
    def device_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """device_id is the device ID"""

    def __init__(
        self,
        *,
        device_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["device_id", b"device_id"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["device_id", b"device_id"]) -> None: ...

global___DeviceLifecycleSummaryKey = DeviceLifecycleSummaryKey

@typing.final
class SoftwareEOL(google.protobuf.message.Message):
    """SoftwareEOL represents a software end of life"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VERSION_FIELD_NUMBER: builtins.int
    END_OF_SUPPORT_FIELD_NUMBER: builtins.int
    @property
    def version(self) -> google.protobuf.wrappers_pb2.StringValue:
        """version of a SoftwareEOL"""

    @property
    def end_of_support(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """end_of_support of a SoftwareEOL"""

    def __init__(
        self,
        *,
        version: google.protobuf.wrappers_pb2.StringValue | None = ...,
        end_of_support: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["end_of_support", b"end_of_support", "version", b"version"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["end_of_support", b"end_of_support", "version", b"version"]) -> None: ...

global___SoftwareEOL = SoftwareEOL

@typing.final
class DateAndModels(google.protobuf.message.Message):
    """DateAndModels has an "end of" date along with
    the models that has this exact "end of" date
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    DATE_FIELD_NUMBER: builtins.int
    MODELS_FIELD_NUMBER: builtins.int
    @property
    def date(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """"end of" date"""

    @property
    def models(self) -> fmp.wrappers_pb2.MapStringInt32:
        """models with this exact "end of" date
        mapped to its count
        """

    def __init__(
        self,
        *,
        date: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        models: fmp.wrappers_pb2.MapStringInt32 | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["date", b"date", "models", b"models"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["date", b"date", "models", b"models"]) -> None: ...

global___DateAndModels = DateAndModels

@typing.final
class HardwareLifecycleSummary(google.protobuf.message.Message):
    """HardwareLifecycleSummary represents a hardware lifecycle summary"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    END_OF_LIFE_FIELD_NUMBER: builtins.int
    END_OF_SALE_FIELD_NUMBER: builtins.int
    END_OF_TAC_SUPPORT_FIELD_NUMBER: builtins.int
    END_OF_HARDWARE_RMA_REQUESTS_FIELD_NUMBER: builtins.int
    @property
    def end_of_life(self) -> global___DateAndModels:
        """end_of_life of a HardwareLifecycleSummary"""

    @property
    def end_of_sale(self) -> global___DateAndModels:
        """end_of_sale of a HardwareLifecycleSummary"""

    @property
    def end_of_tac_support(self) -> global___DateAndModels:
        """end_of_tac_support of a HardwareLifecycleSummary"""

    @property
    def end_of_hardware_rma_requests(self) -> global___DateAndModels:
        """end_of_hardware_rma_requests of a HardwareLifecycleSummary"""

    def __init__(
        self,
        *,
        end_of_life: global___DateAndModels | None = ...,
        end_of_sale: global___DateAndModels | None = ...,
        end_of_tac_support: global___DateAndModels | None = ...,
        end_of_hardware_rma_requests: global___DateAndModels | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["end_of_hardware_rma_requests", b"end_of_hardware_rma_requests", "end_of_life", b"end_of_life", "end_of_sale", b"end_of_sale", "end_of_tac_support", b"end_of_tac_support"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["end_of_hardware_rma_requests", b"end_of_hardware_rma_requests", "end_of_life", b"end_of_life", "end_of_sale", b"end_of_sale", "end_of_tac_support", b"end_of_tac_support"]) -> None: ...

global___HardwareLifecycleSummary = HardwareLifecycleSummary

@typing.final
class DeviceLifecycleSummary(google.protobuf.message.Message):
    """DeviceLifecycleSummary is the state model that represents
    the lifecycle summary of a device
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    SOFTWARE_EOL_FIELD_NUMBER: builtins.int
    HARDWARE_LIFECYCLE_SUMMARY_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> global___DeviceLifecycleSummaryKey:
        """DeviceLifecycleSummaryKey is the key of
        DeviceLifecycleSummary
        """

    @property
    def software_eol(self) -> global___SoftwareEOL:
        """software_eol is the software end of life of
        a device
        """

    @property
    def hardware_lifecycle_summary(self) -> global___HardwareLifecycleSummary:
        """hardware_lifecycle_summary is the hardware lifecycle summary
        of a device
        """

    def __init__(
        self,
        *,
        key: global___DeviceLifecycleSummaryKey | None = ...,
        software_eol: global___SoftwareEOL | None = ...,
        hardware_lifecycle_summary: global___HardwareLifecycleSummary | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["hardware_lifecycle_summary", b"hardware_lifecycle_summary", "key", b"key", "software_eol", b"software_eol"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["hardware_lifecycle_summary", b"hardware_lifecycle_summary", "key", b"key", "software_eol", b"software_eol"]) -> None: ...

global___DeviceLifecycleSummary = DeviceLifecycleSummary
