"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Copyright (c) 2025 Arista Networks, Inc.  All rights reserved.
Use of this source code is governed by the Apache License 2.0
that can be found in the COPYING file.

NOTE: This is a workspace-aware Resource API.
Please see workspace.v1 for more information.
"""

import arista.workspace.v1.workspace_pb2
import builtins
import collections.abc
import fmp.yang_pb2
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import google.protobuf.timestamp_pb2
import google.protobuf.wrappers_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _Element:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _ElementEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_Element.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    ELEMENT_UNSPECIFIED: _Element.ValueType  # 0
    """ELEMENT_UNSPECIFIED indicates an unspecified element type."""
    ELEMENT_DEVICE: _Element.ValueType  # 1
    """ELEMENT_DEVICE indicates a device."""
    ELEMENT_INTERFACE: _Element.ValueType  # 2
    """ELEMENT_INTERFACE indicates an interface."""
    ELEMENT_CONNECTION: _Element.ValueType  # 3
    """ELEMENT_CONNECTION indicates a connection."""

class Element(_Element, metaclass=_ElementEnumTypeWrapper):
    """Element defines the fundamental types of elements in topology."""

ELEMENT_UNSPECIFIED: Element.ValueType  # 0
"""ELEMENT_UNSPECIFIED indicates an unspecified element type."""
ELEMENT_DEVICE: Element.ValueType  # 1
"""ELEMENT_DEVICE indicates a device."""
ELEMENT_INTERFACE: Element.ValueType  # 2
"""ELEMENT_INTERFACE indicates an interface."""
ELEMENT_CONNECTION: Element.ValueType  # 3
"""ELEMENT_CONNECTION indicates a connection."""
global___Element = Element

class _Operation:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _OperationEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_Operation.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    OPERATION_UNSPECIFIED: _Operation.ValueType  # 0
    """OPERATION_UNSPECIFIED indicates an unspecified operation."""
    OPERATION_ADDED: _Operation.ValueType  # 1
    """OPERATION_ADDED indicates addition of an Element."""
    OPERATION_MODIFIED: _Operation.ValueType  # 2
    """OPERATION_MODIFIED indicates modification of an Element."""
    OPERATION_REMOVED: _Operation.ValueType  # 3
    """OPERATION_REMOVED indicates removal of an Element."""

class Operation(_Operation, metaclass=_OperationEnumTypeWrapper):
    """Operation defines the operations that may be performed on the topology."""

OPERATION_UNSPECIFIED: Operation.ValueType  # 0
"""OPERATION_UNSPECIFIED indicates an unspecified operation."""
OPERATION_ADDED: Operation.ValueType  # 1
"""OPERATION_ADDED indicates addition of an Element."""
OPERATION_MODIFIED: Operation.ValueType  # 2
"""OPERATION_MODIFIED indicates modification of an Element."""
OPERATION_REMOVED: Operation.ValueType  # 3
"""OPERATION_REMOVED indicates removal of an Element."""
global___Operation = Operation

class _UpdateStatus:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _UpdateStatusEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_UpdateStatus.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    UPDATE_STATUS_UNSPECIFIED: _UpdateStatus.ValueType  # 0
    """UPDATE_STATUS_UNSPECIFIED indicates an unspecified update status."""
    UPDATE_STATUS_NEW: _UpdateStatus.ValueType  # 1
    """UPDATE_STATUS_NEW indicates the update is new."""
    UPDATE_STATUS_ACCEPTED: _UpdateStatus.ValueType  # 2
    """UPDATE_STATUS_ACCEPTED indicates the update is accepted."""
    UPDATE_STATUS_IGNORED: _UpdateStatus.ValueType  # 3
    """UPDATE_STATUS_IGNORED indicates the update is ignored."""

class UpdateStatus(_UpdateStatus, metaclass=_UpdateStatusEnumTypeWrapper):
    """UpdateStatus defines the set of statuses that apply to individual topology updates."""

UPDATE_STATUS_UNSPECIFIED: UpdateStatus.ValueType  # 0
"""UPDATE_STATUS_UNSPECIFIED indicates an unspecified update status."""
UPDATE_STATUS_NEW: UpdateStatus.ValueType  # 1
"""UPDATE_STATUS_NEW indicates the update is new."""
UPDATE_STATUS_ACCEPTED: UpdateStatus.ValueType  # 2
"""UPDATE_STATUS_ACCEPTED indicates the update is accepted."""
UPDATE_STATUS_IGNORED: UpdateStatus.ValueType  # 3
"""UPDATE_STATUS_IGNORED indicates the update is ignored."""
global___UpdateStatus = UpdateStatus

class _DecommissionStatus:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _DecommissionStatusEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_DecommissionStatus.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    DECOMMISSION_STATUS_UNSPECIFIED: _DecommissionStatus.ValueType  # 0
    """DECOMMISSION_STATUS_UNSPECIFIED indicates that the device was decommissioned with
    an unspecified state.
    """
    DECOMMISSION_STATUS_SUCCESS: _DecommissionStatus.ValueType  # 1
    """DECOMMISSION_STATUS_SUCCESS indicates that the device was successfully decommissioned."""
    DECOMMISSION_STATUS_FAILURE: _DecommissionStatus.ValueType  # 2
    """DECOMMISSION_STATUS_FAILURE indicates an error with decommissioning the device."""

class DecommissionStatus(_DecommissionStatus, metaclass=_DecommissionStatusEnumTypeWrapper):
    """DecommissionStatus enumerates the status of decommissioning a device."""

DECOMMISSION_STATUS_UNSPECIFIED: DecommissionStatus.ValueType  # 0
"""DECOMMISSION_STATUS_UNSPECIFIED indicates that the device was decommissioned with
an unspecified state.
"""
DECOMMISSION_STATUS_SUCCESS: DecommissionStatus.ValueType  # 1
"""DECOMMISSION_STATUS_SUCCESS indicates that the device was successfully decommissioned."""
DECOMMISSION_STATUS_FAILURE: DecommissionStatus.ValueType  # 2
"""DECOMMISSION_STATUS_FAILURE indicates an error with decommissioning the device."""
global___DecommissionStatus = DecommissionStatus

class _ReplaceStatus:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _ReplaceStatusEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_ReplaceStatus.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    REPLACE_STATUS_UNSPECIFIED: _ReplaceStatus.ValueType  # 0
    """REPLACE_STATUS_UNSPECIFIED indicates that the device was replaced with
    an unspecified state.
    """
    REPLACE_STATUS_SUCCESS: _ReplaceStatus.ValueType  # 1
    """REPLACE_STATUS_SUCCESS indicates that the device was successfully replaced."""
    REPLACE_STATUS_FAILURE: _ReplaceStatus.ValueType  # 2
    """REPLACE_STATUS_FAILURE indicates an error with replace."""

class ReplaceStatus(_ReplaceStatus, metaclass=_ReplaceStatusEnumTypeWrapper):
    """ReplaceStatus enumerates the status of the device."""

REPLACE_STATUS_UNSPECIFIED: ReplaceStatus.ValueType  # 0
"""REPLACE_STATUS_UNSPECIFIED indicates that the device was replaced with
an unspecified state.
"""
REPLACE_STATUS_SUCCESS: ReplaceStatus.ValueType  # 1
"""REPLACE_STATUS_SUCCESS indicates that the device was successfully replaced."""
REPLACE_STATUS_FAILURE: ReplaceStatus.ValueType  # 2
"""REPLACE_STATUS_FAILURE indicates an error with replace."""
global___ReplaceStatus = ReplaceStatus

@typing.final
class DeviceInfo(google.protobuf.message.Message):
    """DeviceInfo contains device properties."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    DEVICE_ID_FIELD_NUMBER: builtins.int
    MODEL_NAME_FIELD_NUMBER: builtins.int
    MAC_ADDRESS_FIELD_NUMBER: builtins.int
    HOSTNAME_FIELD_NUMBER: builtins.int
    @property
    def device_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """device_id identifies the device uniquely."""

    @property
    def model_name(self) -> google.protobuf.wrappers_pb2.StringValue:
        """model_name indicates the model of the device."""

    @property
    def mac_address(self) -> fmp.yang_pb2.MACAddress:
        """mac_address indicates the MAC address of the device."""

    @property
    def hostname(self) -> google.protobuf.wrappers_pb2.StringValue:
        """hostname indicates the hostname of the device."""

    def __init__(
        self,
        *,
        device_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
        model_name: google.protobuf.wrappers_pb2.StringValue | None = ...,
        mac_address: fmp.yang_pb2.MACAddress | None = ...,
        hostname: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["device_id", b"device_id", "hostname", b"hostname", "mac_address", b"mac_address", "model_name", b"model_name"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["device_id", b"device_id", "hostname", b"hostname", "mac_address", b"mac_address", "model_name", b"model_name"]) -> None: ...

global___DeviceInfo = DeviceInfo

@typing.final
class InterfaceInfo(google.protobuf.message.Message):
    """InterfaceInfo contains interface properties."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    NEIGHBOR_DEVICE_ID_FIELD_NUMBER: builtins.int
    NEIGHBOR_INTERFACE_NAME_FIELD_NUMBER: builtins.int
    @property
    def name(self) -> google.protobuf.wrappers_pb2.StringValue:
        """name is the name of an interface."""

    @property
    def neighbor_device_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """neighbor_device_id indicates the device ID of the neighbor to which
        this interface is connected.
        """

    @property
    def neighbor_interface_name(self) -> google.protobuf.wrappers_pb2.StringValue:
        """neighbor_interface_name indicates the interface on the neighbor to which
        this interface is connected.
        """

    def __init__(
        self,
        *,
        name: google.protobuf.wrappers_pb2.StringValue | None = ...,
        neighbor_device_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
        neighbor_interface_name: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["name", b"name", "neighbor_device_id", b"neighbor_device_id", "neighbor_interface_name", b"neighbor_interface_name"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["name", b"name", "neighbor_device_id", b"neighbor_device_id", "neighbor_interface_name", b"neighbor_interface_name"]) -> None: ...

global___InterfaceInfo = InterfaceInfo

@typing.final
class InterfaceInfos(google.protobuf.message.Message):
    """InterfaceInfos is a list of InterfaceInfo."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUES_FIELD_NUMBER: builtins.int
    @property
    def values(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___InterfaceInfo]:
        """values is a list of InterfaceInfo."""

    def __init__(
        self,
        *,
        values: collections.abc.Iterable[global___InterfaceInfo] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["values", b"values"]) -> None: ...

global___InterfaceInfos = InterfaceInfos

@typing.final
class DeviceKey(google.protobuf.message.Message):
    """DeviceKey uniquely identifies the device for a workspace."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    WORKSPACE_ID_FIELD_NUMBER: builtins.int
    DEVICE_ID_FIELD_NUMBER: builtins.int
    @property
    def workspace_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """workspace_id identifies the workspace uniquely."""

    @property
    def device_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """device_id identifies the device uniquely."""

    def __init__(
        self,
        *,
        workspace_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
        device_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["device_id", b"device_id", "workspace_id", b"workspace_id"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["device_id", b"device_id", "workspace_id", b"workspace_id"]) -> None: ...

global___DeviceKey = DeviceKey

@typing.final
class DeviceInputConfig(google.protobuf.message.Message):
    """DeviceInputConfig is the desired topology input for a device."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    DEVICE_INFO_FIELD_NUMBER: builtins.int
    REMOVE_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> global___DeviceKey:
        """key uniquely identifies the device ID for a given workspace."""

    @property
    def device_info(self) -> global___DeviceInfo:
        """device_info contains device properties."""

    @property
    def remove(self) -> google.protobuf.wrappers_pb2.BoolValue:
        """remove if set to true will remove the device from mainline
        post workspace merge
        """

    def __init__(
        self,
        *,
        key: global___DeviceKey | None = ...,
        device_info: global___DeviceInfo | None = ...,
        remove: google.protobuf.wrappers_pb2.BoolValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["device_info", b"device_info", "key", b"key", "remove", b"remove"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["device_info", b"device_info", "key", b"key", "remove", b"remove"]) -> None: ...

global___DeviceInputConfig = DeviceInputConfig

@typing.final
class InterfaceInputKey(google.protobuf.message.Message):
    """InterfaceInputKey is the set of inputs that uniquely identify
    the interface for a workspace.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    WORKSPACE_ID_FIELD_NUMBER: builtins.int
    DEVICE_ID_FIELD_NUMBER: builtins.int
    INTERFACE_ID_FIELD_NUMBER: builtins.int
    @property
    def workspace_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """workspace_id identifies the workspace uniquely."""

    @property
    def device_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """device_id identifies the device uniquely."""

    @property
    def interface_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """interface_id along with device_id identifies the interface uniquely."""

    def __init__(
        self,
        *,
        workspace_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
        device_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
        interface_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["device_id", b"device_id", "interface_id", b"interface_id", "workspace_id", b"workspace_id"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["device_id", b"device_id", "interface_id", b"interface_id", "workspace_id", b"workspace_id"]) -> None: ...

global___InterfaceInputKey = InterfaceInputKey

@typing.final
class InterfaceInputConfig(google.protobuf.message.Message):
    """InterfaceInputConfig is the resource for manually adding
    an interface in I&T studios
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    INTERFACE_INFO_FIELD_NUMBER: builtins.int
    REMOVE_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> global___InterfaceInputKey:
        """key uniquely identifies the interface for a given workspace."""

    @property
    def interface_info(self) -> global___InterfaceInfo:
        """interface_info contains interface properties."""

    @property
    def remove(self) -> google.protobuf.wrappers_pb2.BoolValue:
        """remove if set to true will remove the interface from mainline
        post workspace merge
        """

    def __init__(
        self,
        *,
        key: global___InterfaceInputKey | None = ...,
        interface_info: global___InterfaceInfo | None = ...,
        remove: google.protobuf.wrappers_pb2.BoolValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["interface_info", b"interface_info", "key", b"key", "remove", b"remove"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["interface_info", b"interface_info", "key", b"key", "remove", b"remove"]) -> None: ...

global___InterfaceInputConfig = InterfaceInputConfig

@typing.final
class DeviceState(google.protobuf.message.Message):
    """DeviceState is the state of a device written by
    InterfaceInputConfig, DeviceInputConfig and
    UpdateConfig resources
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    DEVICE_INFO_FIELD_NUMBER: builtins.int
    INTERFACE_INFOS_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> global___DeviceKey:
        """key uniquely identifies the device for a given workspace."""

    @property
    def device_info(self) -> global___DeviceInfo:
        """device_info contains device properties"""

    @property
    def interface_infos(self) -> global___InterfaceInfos:
        """interface_infos contains interface properties of all the interfaces
        belonging to the device
        """

    def __init__(
        self,
        *,
        key: global___DeviceKey | None = ...,
        device_info: global___DeviceInfo | None = ...,
        interface_infos: global___InterfaceInfos | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["device_info", b"device_info", "interface_infos", b"interface_infos", "key", b"key"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["device_info", b"device_info", "interface_infos", b"interface_infos", "key", b"key"]) -> None: ...

global___DeviceState = DeviceState

@typing.final
class UpdateKey(google.protobuf.message.Message):
    """UpdateKey uniquely identifies a workspace topology update."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    WORKSPACE_ID_FIELD_NUMBER: builtins.int
    UPDATE_ID_FIELD_NUMBER: builtins.int
    @property
    def workspace_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """workspace_id identifies the workspace uniquely."""

    @property
    def update_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """update_id identifies the update uniquely."""

    def __init__(
        self,
        *,
        workspace_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
        update_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["update_id", b"update_id", "workspace_id", b"workspace_id"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["update_id", b"update_id", "workspace_id", b"workspace_id"]) -> None: ...

global___UpdateKey = UpdateKey

@typing.final
class UpdateConfig(google.protobuf.message.Message):
    """UpdateConfig contains the acceptance status of an Update."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    REMOVE_FIELD_NUMBER: builtins.int
    status: global___UpdateStatus.ValueType
    """status indicates the status of the topology update."""
    @property
    def key(self) -> global___UpdateKey:
        """key uniquely identifies the update."""

    @property
    def remove(self) -> google.protobuf.wrappers_pb2.BoolValue:
        """remove if set to true will remove the update key from mainline
        post workspace merge. This can only be set true for ignored keys
        since we don't carry accepted keys to mainline post workspace
        merge
        """

    def __init__(
        self,
        *,
        key: global___UpdateKey | None = ...,
        status: global___UpdateStatus.ValueType = ...,
        remove: google.protobuf.wrappers_pb2.BoolValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key", "remove", b"remove"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["key", b"key", "remove", b"remove", "status", b"status"]) -> None: ...

global___UpdateConfig = UpdateConfig

@typing.final
class Update(google.protobuf.message.Message):
    """Update represents an update on to the workspace."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    ELEMENT_FIELD_NUMBER: builtins.int
    OPERATION_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    DEVICE_ID_FIELD_NUMBER: builtins.int
    element: global___Element.ValueType
    """element indicates the type of a network element."""
    operation: global___Operation.ValueType
    """operation indicates the type of operation on the topology update."""
    status: global___UpdateStatus.ValueType
    """status indicates the status of the topology update."""
    @property
    def key(self) -> global___UpdateKey:
        """key uniquely identifies the update."""

    @property
    def description(self) -> google.protobuf.wrappers_pb2.StringValue:
        """description describes the topology update in short."""

    @property
    def device_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """device_id indicates the device associated with the update."""

    def __init__(
        self,
        *,
        key: global___UpdateKey | None = ...,
        element: global___Element.ValueType = ...,
        operation: global___Operation.ValueType = ...,
        status: global___UpdateStatus.ValueType = ...,
        description: google.protobuf.wrappers_pb2.StringValue | None = ...,
        device_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["description", b"description", "device_id", b"device_id", "key", b"key"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["description", b"description", "device_id", b"device_id", "element", b"element", "key", b"key", "operation", b"operation", "status", b"status"]) -> None: ...

global___Update = Update

@typing.final
class UpdateSyncConfig(google.protobuf.message.Message):
    """UpdateSyncConfig model represents a point in time all updates
    are to be accepted.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    SYNC_TIME_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> arista.workspace.v1.workspace_pb2.WorkspaceKey:
        """key uniquely identifies the workspace."""

    @property
    def sync_time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """sync_time indicates the desired synchronization time with the live topology.
        If the sync_time indicated in the config takes effect without error,
        it will appear in the state model, and then all updates that occurred up to
        and including the timestamp in the state model will be accepted.
        """

    def __init__(
        self,
        *,
        key: arista.workspace.v1.workspace_pb2.WorkspaceKey | None = ...,
        sync_time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key", "sync_time", b"sync_time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["key", b"key", "sync_time", b"sync_time"]) -> None: ...

global___UpdateSyncConfig = UpdateSyncConfig

@typing.final
class RevertConfig(google.protobuf.message.Message):
    """RevertConfig is the model provided to revert a workspace."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> arista.workspace.v1.workspace_pb2.WorkspaceKey:
        """key uniquely identifies the workspace."""

    def __init__(
        self,
        *,
        key: arista.workspace.v1.workspace_pb2.WorkspaceKey | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["key", b"key"]) -> None: ...

global___RevertConfig = RevertConfig

@typing.final
class DecommissionConfig(google.protobuf.message.Message):
    """DecommissionConfig is the resource for decommissioning
    the device from the studio.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> global___DeviceKey:
        """key uniquely identifies the device for a given workspace."""

    def __init__(
        self,
        *,
        key: global___DeviceKey | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["key", b"key"]) -> None: ...

global___DecommissionConfig = DecommissionConfig

@typing.final
class Decommission(google.protobuf.message.Message):
    """Decommission is the resource that holds the decommissioning
    state of a device.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    CREATED_AT_FIELD_NUMBER: builtins.int
    CREATED_BY_FIELD_NUMBER: builtins.int
    LAST_MODIFIED_AT_FIELD_NUMBER: builtins.int
    LAST_MODIFIED_BY_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    status: global___DecommissionStatus.ValueType
    """status of the decommissioning operation"""
    @property
    def key(self) -> global___DeviceKey:
        """key uniquely identifies the device in a given workspace."""

    @property
    def created_at(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """created_at is the time at which decommissioning was first initiated."""

    @property
    def created_by(self) -> google.protobuf.wrappers_pb2.StringValue:
        """created_by is the name of the user who first initiated decommissioning."""

    @property
    def last_modified_at(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """last_modified_at is the time at which the decommissioning was last modified."""

    @property
    def last_modified_by(self) -> google.protobuf.wrappers_pb2.StringValue:
        """last_modified_by is the name of the user that last modified the status."""

    @property
    def error(self) -> google.protobuf.wrappers_pb2.StringValue:
        """error indicates if there is a failure in decommissioning"""

    def __init__(
        self,
        *,
        key: global___DeviceKey | None = ...,
        created_at: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        created_by: google.protobuf.wrappers_pb2.StringValue | None = ...,
        last_modified_at: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        last_modified_by: google.protobuf.wrappers_pb2.StringValue | None = ...,
        status: global___DecommissionStatus.ValueType = ...,
        error: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["created_at", b"created_at", "created_by", b"created_by", "error", b"error", "key", b"key", "last_modified_at", b"last_modified_at", "last_modified_by", b"last_modified_by"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["created_at", b"created_at", "created_by", b"created_by", "error", b"error", "key", b"key", "last_modified_at", b"last_modified_at", "last_modified_by", b"last_modified_by", "status", b"status"]) -> None: ...

global___Decommission = Decommission

@typing.final
class ReplaceConfig(google.protobuf.message.Message):
    """ReplaceConfig is the resource for replacing a device with another device in Studios."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    REPLACEMENT_DEVICE_ID_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> global___DeviceKey:
        """key uniquely identifies the original device to be replaced in a given workspace."""

    @property
    def replacement_device_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """replacement_device_id is the device to replace the original device with.
        All references to the original device in Studios and tags will be replaced with this device.
        """

    def __init__(
        self,
        *,
        key: global___DeviceKey | None = ...,
        replacement_device_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key", "replacement_device_id", b"replacement_device_id"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["key", b"key", "replacement_device_id", b"replacement_device_id"]) -> None: ...

global___ReplaceConfig = ReplaceConfig

@typing.final
class Replace(google.protobuf.message.Message):
    """Replace is the resource that holds the status of the replace operation."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    REPLACEMENT_DEVICE_ID_FIELD_NUMBER: builtins.int
    CREATED_AT_FIELD_NUMBER: builtins.int
    CREATED_BY_FIELD_NUMBER: builtins.int
    LAST_MODIFIED_AT_FIELD_NUMBER: builtins.int
    LAST_MODIFIED_BY_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    status: global___ReplaceStatus.ValueType
    """status indicates the status of the replace operation."""
    @property
    def key(self) -> global___DeviceKey:
        """key uniquely identifies the original device for a given workspace."""

    @property
    def replacement_device_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """replacement_device_id is the device to replace the original device with."""

    @property
    def created_at(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """created_at is the time at which the status was first set."""

    @property
    def created_by(self) -> google.protobuf.wrappers_pb2.StringValue:
        """created_by is the name of the user that first set the status."""

    @property
    def last_modified_at(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """last_modified_at is the time at which the status was last modified."""

    @property
    def last_modified_by(self) -> google.protobuf.wrappers_pb2.StringValue:
        """last_modified_by is the name of the user that last modified the status."""

    @property
    def error(self) -> google.protobuf.wrappers_pb2.StringValue:
        """error provides the reason if there is a failure in replace."""

    def __init__(
        self,
        *,
        key: global___DeviceKey | None = ...,
        replacement_device_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
        created_at: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        created_by: google.protobuf.wrappers_pb2.StringValue | None = ...,
        last_modified_at: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        last_modified_by: google.protobuf.wrappers_pb2.StringValue | None = ...,
        status: global___ReplaceStatus.ValueType = ...,
        error: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["created_at", b"created_at", "created_by", b"created_by", "error", b"error", "key", b"key", "last_modified_at", b"last_modified_at", "last_modified_by", b"last_modified_by", "replacement_device_id", b"replacement_device_id"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["created_at", b"created_at", "created_by", b"created_by", "error", b"error", "key", b"key", "last_modified_at", b"last_modified_at", "last_modified_by", b"last_modified_by", "replacement_device_id", b"replacement_device_id", "status", b"status"]) -> None: ...

global___Replace = Replace
