"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
CloudVision allows users to version control provisioning operations
that impact device configuration and image management. A workspace is
something like a git branch, within which changes can be made without
immediately impacting a device's running configuration. Changes can be
made, modified, and previewed in a workspace. Once satisfied with the
set of changes, a user may submit a workspace to the "mainline" branch,
allowing the changes to be propagated to devices via Change Controls.

A workspace comprises a set of diff operations (e.g., add/modify/remove)
that will be applied to the mainline if the workspace is submitted
successfully.

A workspace itself is generic and can be used for any conceivable
set of device provisioning operations, but it is not capable of
describing the specific kind of changes. Rather, it holds changes
defined by other Resource APIs that are "workspace-aware", such as
studio.v1 and tag.v2. These APIs allow users to make changes within
the context of a specific workspace, identified in the resource key
with the field `workspace_id`.
"""

import arista.configstatus.v1.configstatus_pb2
import arista.imagestatus.v1.imagestatus_pb2
import builtins
import collections.abc
import fmp.wrappers_pb2
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import google.protobuf.timestamp_pb2
import google.protobuf.wrappers_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _WorkspaceState:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _WorkspaceStateEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_WorkspaceState.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    WORKSPACE_STATE_UNSPECIFIED: _WorkspaceState.ValueType  # 0
    """WORKSPACE_STATE_UNSPECIFIED indicates unspecified workspace state."""
    WORKSPACE_STATE_PENDING: _WorkspaceState.ValueType  # 1
    """WORKSPACE_STATE_PENDING indicates that the changes in the workspace are open and
    have not been submitted.
    """
    WORKSPACE_STATE_SUBMITTED: _WorkspaceState.ValueType  # 2
    """WORKSPACE_STATE_SUBMITTED indicates that the changes in the workspace have been
    submitted to the mainline.
    """
    WORKSPACE_STATE_ABANDONED: _WorkspaceState.ValueType  # 3
    """WORKSPACE_STATE_ABANDONED indicates that the workspace has been intentionally
    closed, and may no longer be updated.
    """
    WORKSPACE_STATE_CONFLICTS: _WorkspaceState.ValueType  # 4
    """WORKSPACE_STATE_CONFLICTS indicates that the changes in the workspace are in
    conflict with the current state of the system.
    """
    WORKSPACE_STATE_ROLLED_BACK: _WorkspaceState.ValueType  # 5
    """WORKSPACE_STATE_ROLLED_BACK indicates that the workspace was submitted, but
    has been rolled back (the changes have been undone).
    """

class WorkspaceState(_WorkspaceState, metaclass=_WorkspaceStateEnumTypeWrapper):
    """WorkspaceState enumerates the general states of a workspace. Some of these states
    are derived as a result of executing a specific request on the workspace (see Request).
    """

WORKSPACE_STATE_UNSPECIFIED: WorkspaceState.ValueType  # 0
"""WORKSPACE_STATE_UNSPECIFIED indicates unspecified workspace state."""
WORKSPACE_STATE_PENDING: WorkspaceState.ValueType  # 1
"""WORKSPACE_STATE_PENDING indicates that the changes in the workspace are open and
have not been submitted.
"""
WORKSPACE_STATE_SUBMITTED: WorkspaceState.ValueType  # 2
"""WORKSPACE_STATE_SUBMITTED indicates that the changes in the workspace have been
submitted to the mainline.
"""
WORKSPACE_STATE_ABANDONED: WorkspaceState.ValueType  # 3
"""WORKSPACE_STATE_ABANDONED indicates that the workspace has been intentionally
closed, and may no longer be updated.
"""
WORKSPACE_STATE_CONFLICTS: WorkspaceState.ValueType  # 4
"""WORKSPACE_STATE_CONFLICTS indicates that the changes in the workspace are in
conflict with the current state of the system.
"""
WORKSPACE_STATE_ROLLED_BACK: WorkspaceState.ValueType  # 5
"""WORKSPACE_STATE_ROLLED_BACK indicates that the workspace was submitted, but
has been rolled back (the changes have been undone).
"""
global___WorkspaceState = WorkspaceState

class _Request:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _RequestEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_Request.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    REQUEST_UNSPECIFIED: _Request.ValueType  # 0
    """REQUEST_UNSPECIFIED describes unspecified request."""
    REQUEST_START_BUILD: _Request.ValueType  # 1
    """REQUEST_START_BUILD describes a request to start building a workspace. This kicks
    of a multi-stage operation to compile and validate the changes in a workspace (see
    BuildStage for more details).
    """
    REQUEST_CANCEL_BUILD: _Request.ValueType  # 2
    """REQUEST_CANCEL_BUILD describes a request to stop building a workspace."""
    REQUEST_SUBMIT: _Request.ValueType  # 3
    """REQUEST_SUBMIT describes a request to submit a workspace to the mainline. Before
    submission, some checks are made that can cause the request to fail. E.g., if there
    is a modified configuration for a non-streaming device in the workspace, then the
    request will fail. Once submitted, changes are applied and change controls are
    created (if necessary).
    """
    REQUEST_ABANDON: _Request.ValueType  # 4
    """REQUEST_ABANDON describes a request to abandon a workspace. This operation does
    not delete the workspace from the system, but closes it to any further updates.
    """
    REQUEST_ROLLBACK: _Request.ValueType  # 5
    """REQUEST_ROLLBACK describes a request to rollback a submitted workspace, undoing
    corresponding changes in the mainline.
    """
    REQUEST_SUBMIT_FORCE: _Request.ValueType  # 6
    """REQUEST_SUBMIT_FORCE describes a request to submit a workspace without making any
    checks that could normally cause the submission to fail. See REQUEST_SUBMIT for
    more details.
    """
    REQUEST_REBASE: _Request.ValueType  # 7
    """REQUEST_REBASE describes a request to rebase a workspace. This operation updates
    workspace state to reflect the latest mainline content, and re-applies workspace
    changes on top of that.
    """

class Request(_Request, metaclass=_RequestEnumTypeWrapper):
    """Request enumerates the set of asynchronous operations that can be performed on a
    workspace.
    """

REQUEST_UNSPECIFIED: Request.ValueType  # 0
"""REQUEST_UNSPECIFIED describes unspecified request."""
REQUEST_START_BUILD: Request.ValueType  # 1
"""REQUEST_START_BUILD describes a request to start building a workspace. This kicks
of a multi-stage operation to compile and validate the changes in a workspace (see
BuildStage for more details).
"""
REQUEST_CANCEL_BUILD: Request.ValueType  # 2
"""REQUEST_CANCEL_BUILD describes a request to stop building a workspace."""
REQUEST_SUBMIT: Request.ValueType  # 3
"""REQUEST_SUBMIT describes a request to submit a workspace to the mainline. Before
submission, some checks are made that can cause the request to fail. E.g., if there
is a modified configuration for a non-streaming device in the workspace, then the
request will fail. Once submitted, changes are applied and change controls are
created (if necessary).
"""
REQUEST_ABANDON: Request.ValueType  # 4
"""REQUEST_ABANDON describes a request to abandon a workspace. This operation does
not delete the workspace from the system, but closes it to any further updates.
"""
REQUEST_ROLLBACK: Request.ValueType  # 5
"""REQUEST_ROLLBACK describes a request to rollback a submitted workspace, undoing
corresponding changes in the mainline.
"""
REQUEST_SUBMIT_FORCE: Request.ValueType  # 6
"""REQUEST_SUBMIT_FORCE describes a request to submit a workspace without making any
checks that could normally cause the submission to fail. See REQUEST_SUBMIT for
more details.
"""
REQUEST_REBASE: Request.ValueType  # 7
"""REQUEST_REBASE describes a request to rebase a workspace. This operation updates
workspace state to reflect the latest mainline content, and re-applies workspace
changes on top of that.
"""
global___Request = Request

class _ResponseStatus:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _ResponseStatusEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_ResponseStatus.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    RESPONSE_STATUS_UNSPECIFIED: _ResponseStatus.ValueType  # 0
    """RESPONSE_STATUS_UNSPECIFIED indicates unspecified response status."""
    RESPONSE_STATUS_SUCCESS: _ResponseStatus.ValueType  # 1
    """RESPONSE_STATUS_SUCCESS indicates that the original Request was successful
    in its execution.
    """
    RESPONSE_STATUS_FAIL: _ResponseStatus.ValueType  # 2
    """RESPONSE_STATUS_FAIL indicates that the original Request was unsuccessful
    in its execution.
    """

class ResponseStatus(_ResponseStatus, metaclass=_ResponseStatusEnumTypeWrapper):
    """ResponseStatus enumerates the set of execution statuses of a Response."""

RESPONSE_STATUS_UNSPECIFIED: ResponseStatus.ValueType  # 0
"""RESPONSE_STATUS_UNSPECIFIED indicates unspecified response status."""
RESPONSE_STATUS_SUCCESS: ResponseStatus.ValueType  # 1
"""RESPONSE_STATUS_SUCCESS indicates that the original Request was successful
in its execution.
"""
RESPONSE_STATUS_FAIL: ResponseStatus.ValueType  # 2
"""RESPONSE_STATUS_FAIL indicates that the original Request was unsuccessful
in its execution.
"""
global___ResponseStatus = ResponseStatus

class _ResponseCode:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _ResponseCodeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_ResponseCode.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    RESPONSE_CODE_UNSPECIFIED: _ResponseCode.ValueType  # 0
    """RESPONSE_CODE_UNSPECIFIED indicates unspecified response code."""
    RESPONSE_CODE_INACTIVE_DEVICES_EXIST: _ResponseCode.ValueType  # 1
    """RESPONSE_CODE_INACTIVE_DEVICES_EXIST indicates that there are devices that have inactive
    streaming status.
    """
    RESPONSE_CODE_DECOMMISSION_DEVICES_INCOMPLETE: _ResponseCode.ValueType  # 2
    """RESPONSE_CODE_DECOMMISSION_DEVICES_INCOMPLETE indicates that the decommission process is
    incomplete for devices.
    """

class ResponseCode(_ResponseCode, metaclass=_ResponseCodeEnumTypeWrapper):
    """ResponseCode is a code for a Response indicating a particular scenario."""

RESPONSE_CODE_UNSPECIFIED: ResponseCode.ValueType  # 0
"""RESPONSE_CODE_UNSPECIFIED indicates unspecified response code."""
RESPONSE_CODE_INACTIVE_DEVICES_EXIST: ResponseCode.ValueType  # 1
"""RESPONSE_CODE_INACTIVE_DEVICES_EXIST indicates that there are devices that have inactive
streaming status.
"""
RESPONSE_CODE_DECOMMISSION_DEVICES_INCOMPLETE: ResponseCode.ValueType  # 2
"""RESPONSE_CODE_DECOMMISSION_DEVICES_INCOMPLETE indicates that the decommission process is
incomplete for devices.
"""
global___ResponseCode = ResponseCode

class _BuildState:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _BuildStateEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_BuildState.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    BUILD_STATE_UNSPECIFIED: _BuildState.ValueType  # 0
    """BUILD_STATE_UNSPECIFIED indicates unspecified build state."""
    BUILD_STATE_IN_PROGRESS: _BuildState.ValueType  # 1
    """BUILD_STATE_IN_PROGRESS indicates that the BuildStage was started but has
    not yet completed.
    """
    BUILD_STATE_CANCELED: _BuildState.ValueType  # 2
    """BUILD_STATE_CANCELED indicates that the BuildStage was started but then
    stopped before completion.
    """
    BUILD_STATE_SUCCESS: _BuildState.ValueType  # 3
    """BUILD_STATE_SUCCESS indicates that the BuildStage was started and ran to
    completion successfully.
    """
    BUILD_STATE_FAIL: _BuildState.ValueType  # 4
    """BUILD_STATE_FAIL indicates that the BuildStage was started and ran to
    completion unsuccessfully.
    """
    BUILD_STATE_SKIPPED: _BuildState.ValueType  # 5
    """BUILD_STATE_SKIPPED indicates that the BuildStage was not run."""

class BuildState(_BuildState, metaclass=_BuildStateEnumTypeWrapper):
    """BuildState enumerates the set of states that a BuildStage can be in during a
    workspace build cycle.
    """

BUILD_STATE_UNSPECIFIED: BuildState.ValueType  # 0
"""BUILD_STATE_UNSPECIFIED indicates unspecified build state."""
BUILD_STATE_IN_PROGRESS: BuildState.ValueType  # 1
"""BUILD_STATE_IN_PROGRESS indicates that the BuildStage was started but has
not yet completed.
"""
BUILD_STATE_CANCELED: BuildState.ValueType  # 2
"""BUILD_STATE_CANCELED indicates that the BuildStage was started but then
stopped before completion.
"""
BUILD_STATE_SUCCESS: BuildState.ValueType  # 3
"""BUILD_STATE_SUCCESS indicates that the BuildStage was started and ran to
completion successfully.
"""
BUILD_STATE_FAIL: BuildState.ValueType  # 4
"""BUILD_STATE_FAIL indicates that the BuildStage was started and ran to
completion unsuccessfully.
"""
BUILD_STATE_SKIPPED: BuildState.ValueType  # 5
"""BUILD_STATE_SKIPPED indicates that the BuildStage was not run."""
global___BuildState = BuildState

class _BuildStage:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _BuildStageEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_BuildStage.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    BUILD_STAGE_UNSPECIFIED: _BuildStage.ValueType  # 0
    """BUILD_STAGE_UNSPECIFIED indicates unspecified build stage."""
    BUILD_STAGE_INPUT_VALIDATION: _BuildStage.ValueType  # 1
    """BUILD_STAGE_INPUT_VALIDATION describes the stage that detects input
    errors in studios based on their schemas.
    """
    BUILD_STAGE_CONFIGLET_BUILD: _BuildStage.ValueType  # 2
    """BUILD_STAGE_CONFIGLET_BUILD describes the stage that generates EOS CLI
    configs and images for devices by evaluating studio templates against
    their inputs.
    """
    BUILD_STAGE_CONFIG_VALIDATION: _BuildStage.ValueType  # 3
    """BUILD_STAGE_CONFIG_VALIDATION describes the stage that validates the
    generated EOS CLI configs (e.g., checks for errors in the config).
    """
    BUILD_STAGE_IMAGE_VALIDATION: _BuildStage.ValueType  # 4
    """BUILD_STAGE_IMAGE_VALIDATION describes the stage that validates the
    generated images (e.g., checks device compatibility).
    """

class BuildStage(_BuildStage, metaclass=_BuildStageEnumTypeWrapper):
    """BuildStage enumerates the types of stages of a build of a workspace."""

BUILD_STAGE_UNSPECIFIED: BuildStage.ValueType  # 0
"""BUILD_STAGE_UNSPECIFIED indicates unspecified build stage."""
BUILD_STAGE_INPUT_VALIDATION: BuildStage.ValueType  # 1
"""BUILD_STAGE_INPUT_VALIDATION describes the stage that detects input
errors in studios based on their schemas.
"""
BUILD_STAGE_CONFIGLET_BUILD: BuildStage.ValueType  # 2
"""BUILD_STAGE_CONFIGLET_BUILD describes the stage that generates EOS CLI
configs and images for devices by evaluating studio templates against
their inputs.
"""
BUILD_STAGE_CONFIG_VALIDATION: BuildStage.ValueType  # 3
"""BUILD_STAGE_CONFIG_VALIDATION describes the stage that validates the
generated EOS CLI configs (e.g., checks for errors in the config).
"""
BUILD_STAGE_IMAGE_VALIDATION: BuildStage.ValueType  # 4
"""BUILD_STAGE_IMAGE_VALIDATION describes the stage that validates the
generated images (e.g., checks device compatibility).
"""
global___BuildStage = BuildStage

class _DeviceAuthzStatus:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _DeviceAuthzStatusEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_DeviceAuthzStatus.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    DEVICE_AUTHZ_STATUS_UNSPECIFIED: _DeviceAuthzStatus.ValueType  # 0
    """DEVICE_AUTHZ_STATUS_UNSPECIFIED indicates the authorization check is pending."""
    DEVICE_AUTHZ_STATUS_AUTHORIZED: _DeviceAuthzStatus.ValueType  # 1
    """DEVICE_AUTHZ_STATUS_AUTHORIZED indicates the subject
    is authorized to provision this device.
    """
    DEVICE_AUTHZ_STATUS_UNAUTHORIZED: _DeviceAuthzStatus.ValueType  # 2
    """DEVICE_AUTHZ_STATUS_UNAUTHORIZED indicates the subject
    is unauthorized to provision this device.
    """

class DeviceAuthzStatus(_DeviceAuthzStatus, metaclass=_DeviceAuthzStatusEnumTypeWrapper):
    """DeviceAuthzStatus holds the result of the authorization check on device."""

DEVICE_AUTHZ_STATUS_UNSPECIFIED: DeviceAuthzStatus.ValueType  # 0
"""DEVICE_AUTHZ_STATUS_UNSPECIFIED indicates the authorization check is pending."""
DEVICE_AUTHZ_STATUS_AUTHORIZED: DeviceAuthzStatus.ValueType  # 1
"""DEVICE_AUTHZ_STATUS_AUTHORIZED indicates the subject
is authorized to provision this device.
"""
DEVICE_AUTHZ_STATUS_UNAUTHORIZED: DeviceAuthzStatus.ValueType  # 2
"""DEVICE_AUTHZ_STATUS_UNAUTHORIZED indicates the subject
is unauthorized to provision this device.
"""
global___DeviceAuthzStatus = DeviceAuthzStatus

class _ConfigValidationSkipCause:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _ConfigValidationSkipCauseEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_ConfigValidationSkipCause.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    CONFIG_VALIDATION_SKIP_CAUSE_UNSPECIFIED: _ConfigValidationSkipCause.ValueType  # 0
    """CONFIG_VALIDATION_SKIP_CAUSE_UNSPECIFIED indicates config validation skip cause is
    unspecified.
    """
    CONFIG_VALIDATION_SKIP_CAUSE_INACTIVE: _ConfigValidationSkipCause.ValueType  # 1
    """CONFIG_VALIDATION_SKIP_CAUSE_INACTIVE indicates that the stage was skipped
    because the device is not streaming.
    """
    CONFIG_VALIDATION_SKIP_CAUSE_PRE_PROVISIONED: _ConfigValidationSkipCause.ValueType  # 2
    """CONFIG_VALIDATION_SKIP_CAUSE_PRE_PROVISIONED indicates that the stage was
    skipped because the device is pre-provisioned.
    """
    CONFIG_VALIDATION_SKIP_CAUSE_CONFIG_UNCHANGED: _ConfigValidationSkipCause.ValueType  # 3
    """CONFIG_VALIDATION_SKIP_CAUSE_CONFIG_UNCHANGED indicates that the stage was
    skipped because the device has no configuration changes in the workspace.
    """
    CONFIG_VALIDATION_SKIP_CAUSE_NO_CONFIG_SOURCES: _ConfigValidationSkipCause.ValueType  # 4
    """CONFIG_VALIDATION_SKIP_CAUSE_NO_CONFIG_SOURCES indicates that the stage was
    skipped because the device has no config sources in the workspace.
    """
    CONFIG_VALIDATION_SKIP_CAUSE_DEVICE_DECOMMISSIONED: _ConfigValidationSkipCause.ValueType  # 5
    """CONFIG_VALIDATION_SKIP_CAUSE_DEVICE_DECOMMISSIONED indicates that the stage was
    skipped because the device is decommissioned in the workspace.
    """
    CONFIG_VALIDATION_SKIP_CAUSE_DEVICE_REPLACED: _ConfigValidationSkipCause.ValueType  # 6
    """CONFIG_VALIDATION_SKIP_CAUSE_DEVICE_REPLACED indicates that the stage was
    skipped because the device is replaced in the workspace.
    """

class ConfigValidationSkipCause(_ConfigValidationSkipCause, metaclass=_ConfigValidationSkipCauseEnumTypeWrapper):
    """ConfigValidationSkipCause enumerates the set of reasons a device can skip the config
    validation stage.
    """

CONFIG_VALIDATION_SKIP_CAUSE_UNSPECIFIED: ConfigValidationSkipCause.ValueType  # 0
"""CONFIG_VALIDATION_SKIP_CAUSE_UNSPECIFIED indicates config validation skip cause is
unspecified.
"""
CONFIG_VALIDATION_SKIP_CAUSE_INACTIVE: ConfigValidationSkipCause.ValueType  # 1
"""CONFIG_VALIDATION_SKIP_CAUSE_INACTIVE indicates that the stage was skipped
because the device is not streaming.
"""
CONFIG_VALIDATION_SKIP_CAUSE_PRE_PROVISIONED: ConfigValidationSkipCause.ValueType  # 2
"""CONFIG_VALIDATION_SKIP_CAUSE_PRE_PROVISIONED indicates that the stage was
skipped because the device is pre-provisioned.
"""
CONFIG_VALIDATION_SKIP_CAUSE_CONFIG_UNCHANGED: ConfigValidationSkipCause.ValueType  # 3
"""CONFIG_VALIDATION_SKIP_CAUSE_CONFIG_UNCHANGED indicates that the stage was
skipped because the device has no configuration changes in the workspace.
"""
CONFIG_VALIDATION_SKIP_CAUSE_NO_CONFIG_SOURCES: ConfigValidationSkipCause.ValueType  # 4
"""CONFIG_VALIDATION_SKIP_CAUSE_NO_CONFIG_SOURCES indicates that the stage was
skipped because the device has no config sources in the workspace.
"""
CONFIG_VALIDATION_SKIP_CAUSE_DEVICE_DECOMMISSIONED: ConfigValidationSkipCause.ValueType  # 5
"""CONFIG_VALIDATION_SKIP_CAUSE_DEVICE_DECOMMISSIONED indicates that the stage was
skipped because the device is decommissioned in the workspace.
"""
CONFIG_VALIDATION_SKIP_CAUSE_DEVICE_REPLACED: ConfigValidationSkipCause.ValueType  # 6
"""CONFIG_VALIDATION_SKIP_CAUSE_DEVICE_REPLACED indicates that the stage was
skipped because the device is replaced in the workspace.
"""
global___ConfigValidationSkipCause = ConfigValidationSkipCause

class _ImageValidationSkipCause:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _ImageValidationSkipCauseEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_ImageValidationSkipCause.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    IMAGE_VALIDATION_SKIP_CAUSE_UNSPECIFIED: _ImageValidationSkipCause.ValueType  # 0
    """IMAGE_VALIDATION_SKIP_CAUSE_UNSPECIFIED indicates image validation skip cause is
    unspecified.
    """
    IMAGE_VALIDATION_SKIP_CAUSE_INACTIVE: _ImageValidationSkipCause.ValueType  # 1
    """IMAGE_VALIDATION_SKIP_CAUSE_INACTIVE indicates that the stage was skipped
    because the device is not streaming.
    """
    IMAGE_VALIDATION_SKIP_CAUSE_PRE_PROVISIONED: _ImageValidationSkipCause.ValueType  # 2
    """IMAGE_VALIDATION_SKIP_CAUSE_PRE_PROVISIONED indicates that the stage was
    skipped because the device is pre-provisioned.
    """
    IMAGE_VALIDATION_SKIP_CAUSE_IMAGE_UNCHANGED: _ImageValidationSkipCause.ValueType  # 3
    """IMAGE_VALIDATION_SKIP_CAUSE_IMAGE_UNCHANGED indicates that the stage was
    skipped because the device has no image changes in the workspace.
    """
    IMAGE_VALIDATION_SKIP_CAUSE_NO_PROPOSED_SOFTWARE: _ImageValidationSkipCause.ValueType  # 4
    """IMAGE_VALIDATION_SKIP_CAUSE_NO_PROPOSED_SOFTWARE indicates that the stage was
    skipped because the device has no proposed software changes in the workspace.
    """
    IMAGE_VALIDATION_SKIP_CAUSE_DEVICE_DECOMMISSIONED: _ImageValidationSkipCause.ValueType  # 5
    """IMAGE_VALIDATION_SKIP_CAUSE_DEVICE_DECOMMISSIONED indicates that the stage was
    skipped because the device is decommissioned.
    """
    IMAGE_VALIDATION_SKIP_CAUSE_DEVICE_REPLACED: _ImageValidationSkipCause.ValueType  # 6
    """IMAGE_VALIDATION_SKIP_CAUSE_DEVICE_REPLACED indicates that the stage was
    skipped because the device is replaced.
    """

class ImageValidationSkipCause(_ImageValidationSkipCause, metaclass=_ImageValidationSkipCauseEnumTypeWrapper):
    """ImageValidationSkipCause enumerates the set of reasons a device can skip the image
    validation stage.
    """

IMAGE_VALIDATION_SKIP_CAUSE_UNSPECIFIED: ImageValidationSkipCause.ValueType  # 0
"""IMAGE_VALIDATION_SKIP_CAUSE_UNSPECIFIED indicates image validation skip cause is
unspecified.
"""
IMAGE_VALIDATION_SKIP_CAUSE_INACTIVE: ImageValidationSkipCause.ValueType  # 1
"""IMAGE_VALIDATION_SKIP_CAUSE_INACTIVE indicates that the stage was skipped
because the device is not streaming.
"""
IMAGE_VALIDATION_SKIP_CAUSE_PRE_PROVISIONED: ImageValidationSkipCause.ValueType  # 2
"""IMAGE_VALIDATION_SKIP_CAUSE_PRE_PROVISIONED indicates that the stage was
skipped because the device is pre-provisioned.
"""
IMAGE_VALIDATION_SKIP_CAUSE_IMAGE_UNCHANGED: ImageValidationSkipCause.ValueType  # 3
"""IMAGE_VALIDATION_SKIP_CAUSE_IMAGE_UNCHANGED indicates that the stage was
skipped because the device has no image changes in the workspace.
"""
IMAGE_VALIDATION_SKIP_CAUSE_NO_PROPOSED_SOFTWARE: ImageValidationSkipCause.ValueType  # 4
"""IMAGE_VALIDATION_SKIP_CAUSE_NO_PROPOSED_SOFTWARE indicates that the stage was
skipped because the device has no proposed software changes in the workspace.
"""
IMAGE_VALIDATION_SKIP_CAUSE_DEVICE_DECOMMISSIONED: ImageValidationSkipCause.ValueType  # 5
"""IMAGE_VALIDATION_SKIP_CAUSE_DEVICE_DECOMMISSIONED indicates that the stage was
skipped because the device is decommissioned.
"""
IMAGE_VALIDATION_SKIP_CAUSE_DEVICE_REPLACED: ImageValidationSkipCause.ValueType  # 6
"""IMAGE_VALIDATION_SKIP_CAUSE_DEVICE_REPLACED indicates that the stage was
skipped because the device is replaced.
"""
global___ImageValidationSkipCause = ImageValidationSkipCause

class _ConfigSyncSkipCause:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _ConfigSyncSkipCauseEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_ConfigSyncSkipCause.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    CONFIG_SYNC_SKIP_CAUSE_UNSPECIFIED: _ConfigSyncSkipCause.ValueType  # 0
    """CONFIG_SYNC_SKIP_CAUSE_UNSPECIFIED indicates that config sync skip cause is
    unspecified.
    """
    CONFIG_SYNC_SKIP_CAUSE_INACTIVE: _ConfigSyncSkipCause.ValueType  # 1
    """CONFIG_SYNC_SKIP_CAUSE_INACTIVE indicates that config sync is skipped because
    device is not streaming.
    """
    CONFIG_SYNC_SKIP_CAUSE_PRE_PROVISIONED: _ConfigSyncSkipCause.ValueType  # 2
    """CONFIG_SYNC_SKIP_CAUSE_PRE_PROVISIONED indicates that config sync is skipped
    because device is pre-provisioned.
    """
    CONFIG_SYNC_SKIP_CAUSE_IN_COMPLIANCE: _ConfigSyncSkipCause.ValueType  # 3
    """CONFIG_SYNC_SKIP_CAUSE_IN_COMPLIANCE indicates that config sync is skipped
    because device is in compliance.
    """
    CONFIG_SYNC_SKIP_CAUSE_NO_CONFIG_SOURCES: _ConfigSyncSkipCause.ValueType  # 4
    """CONFIG_SYNC_SKIP_CAUSE_NO_CONFIG_SOURCES indicates that the sync was
    skipped because the device has no config sources.
    """
    CONFIG_SYNC_SKIP_CAUSE_DEVICE_DECOMMISSIONED: _ConfigSyncSkipCause.ValueType  # 5
    """CONFIG_SYNC_SKIP_CAUSE_DEVICE_DECOMMISSIONED indicates that sync was
    skipped because the device is decommissioned in the workspace.
    """
    CONFIG_SYNC_SKIP_CAUSE_DEVICE_REPLACED: _ConfigSyncSkipCause.ValueType  # 6
    """CONFIG_SYNC_SKIP_CAUSE_DEVICE_REPLACED indicates that sync was
    skipped because the device is replaced in the workspace.
    """

class ConfigSyncSkipCause(_ConfigSyncSkipCause, metaclass=_ConfigSyncSkipCauseEnumTypeWrapper):
    """ConfigSyncSkipCause enumerates the set of reasons a device can skip config sync."""

CONFIG_SYNC_SKIP_CAUSE_UNSPECIFIED: ConfigSyncSkipCause.ValueType  # 0
"""CONFIG_SYNC_SKIP_CAUSE_UNSPECIFIED indicates that config sync skip cause is
unspecified.
"""
CONFIG_SYNC_SKIP_CAUSE_INACTIVE: ConfigSyncSkipCause.ValueType  # 1
"""CONFIG_SYNC_SKIP_CAUSE_INACTIVE indicates that config sync is skipped because
device is not streaming.
"""
CONFIG_SYNC_SKIP_CAUSE_PRE_PROVISIONED: ConfigSyncSkipCause.ValueType  # 2
"""CONFIG_SYNC_SKIP_CAUSE_PRE_PROVISIONED indicates that config sync is skipped
because device is pre-provisioned.
"""
CONFIG_SYNC_SKIP_CAUSE_IN_COMPLIANCE: ConfigSyncSkipCause.ValueType  # 3
"""CONFIG_SYNC_SKIP_CAUSE_IN_COMPLIANCE indicates that config sync is skipped
because device is in compliance.
"""
CONFIG_SYNC_SKIP_CAUSE_NO_CONFIG_SOURCES: ConfigSyncSkipCause.ValueType  # 4
"""CONFIG_SYNC_SKIP_CAUSE_NO_CONFIG_SOURCES indicates that the sync was
skipped because the device has no config sources.
"""
CONFIG_SYNC_SKIP_CAUSE_DEVICE_DECOMMISSIONED: ConfigSyncSkipCause.ValueType  # 5
"""CONFIG_SYNC_SKIP_CAUSE_DEVICE_DECOMMISSIONED indicates that sync was
skipped because the device is decommissioned in the workspace.
"""
CONFIG_SYNC_SKIP_CAUSE_DEVICE_REPLACED: ConfigSyncSkipCause.ValueType  # 6
"""CONFIG_SYNC_SKIP_CAUSE_DEVICE_REPLACED indicates that sync was
skipped because the device is replaced in the workspace.
"""
global___ConfigSyncSkipCause = ConfigSyncSkipCause

class _SyncOperation:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _SyncOperationEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_SyncOperation.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    SYNC_OPERATION_UNSPECIFIED: _SyncOperation.ValueType  # 0
    """SYNC_OPERATION_UNSPECIFIED indicates unspecified sync operation."""
    SYNC_OPERATION_CONFIG: _SyncOperation.ValueType  # 1
    """SYNC_OPERATION_CONFIG indicates config sync operation."""

class SyncOperation(_SyncOperation, metaclass=_SyncOperationEnumTypeWrapper):
    """SyncOperation enumerates sync operations."""

SYNC_OPERATION_UNSPECIFIED: SyncOperation.ValueType  # 0
"""SYNC_OPERATION_UNSPECIFIED indicates unspecified sync operation."""
SYNC_OPERATION_CONFIG: SyncOperation.ValueType  # 1
"""SYNC_OPERATION_CONFIG indicates config sync operation."""
global___SyncOperation = SyncOperation

@typing.final
class RequestParams(google.protobuf.message.Message):
    """RequestParams define the parameters for a Request."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    REQUEST_ID_FIELD_NUMBER: builtins.int
    @property
    def request_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """request_id is the unique ID of the request. This is used to identify
        the Response for the request in Responses.
        """

    def __init__(
        self,
        *,
        request_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["request_id", b"request_id"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["request_id", b"request_id"]) -> None: ...

global___RequestParams = RequestParams

@typing.final
class Response(google.protobuf.message.Message):
    """Response is a response to a Request."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    STATUS_FIELD_NUMBER: builtins.int
    MESSAGE_FIELD_NUMBER: builtins.int
    CODE_FIELD_NUMBER: builtins.int
    status: global___ResponseStatus.ValueType
    """status is the execution status of the response."""
    code: global___ResponseCode.ValueType
    """code is the code of the response."""
    @property
    def message(self) -> google.protobuf.wrappers_pb2.StringValue:
        """message is a string that provides more details about the response."""

    def __init__(
        self,
        *,
        status: global___ResponseStatus.ValueType = ...,
        message: google.protobuf.wrappers_pb2.StringValue | None = ...,
        code: global___ResponseCode.ValueType = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["message", b"message"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["code", b"code", "message", b"message", "status", b"status"]) -> None: ...

global___Response = Response

@typing.final
class Responses(google.protobuf.message.Message):
    """Responses is a collection of responses for completed requests."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class ValuesEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> global___Response: ...
        def __init__(
            self,
            *,
            key: builtins.str = ...,
            value: global___Response | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    VALUES_FIELD_NUMBER: builtins.int
    @property
    def values(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, global___Response]:
        """values is a map from request ID to Response."""

    def __init__(
        self,
        *,
        values: collections.abc.Mapping[builtins.str, global___Response] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["values", b"values"]) -> None: ...

global___Responses = Responses

@typing.final
class WorkspaceKey(google.protobuf.message.Message):
    """WorkspaceKey uniquely identifies a workspace."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    WORKSPACE_ID_FIELD_NUMBER: builtins.int
    @property
    def workspace_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """workspace_id is the unique ID of the workspace."""

    def __init__(
        self,
        *,
        workspace_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["workspace_id", b"workspace_id"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["workspace_id", b"workspace_id"]) -> None: ...

global___WorkspaceKey = WorkspaceKey

@typing.final
class WorkspaceConfig(google.protobuf.message.Message):
    """WorkspaceConfig holds the configuration of a workspace."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    DISPLAY_NAME_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    REQUEST_FIELD_NUMBER: builtins.int
    REQUEST_PARAMS_FIELD_NUMBER: builtins.int
    request: global___Request.ValueType
    """request (if not REQUEST_UNSPECIFIED) kicks off an asynchronous operation
    on the workspace.
    """
    @property
    def key(self) -> global___WorkspaceKey:
        """key identifies the workspace."""

    @property
    def display_name(self) -> google.protobuf.wrappers_pb2.StringValue:
        """display_name is the user-defined name of the workspace."""

    @property
    def description(self) -> google.protobuf.wrappers_pb2.StringValue:
        """description is a brief description of the workspace."""

    @property
    def request_params(self) -> global___RequestParams:
        """request_params specify the parameters for `request`."""

    def __init__(
        self,
        *,
        key: global___WorkspaceKey | None = ...,
        display_name: google.protobuf.wrappers_pb2.StringValue | None = ...,
        description: google.protobuf.wrappers_pb2.StringValue | None = ...,
        request: global___Request.ValueType = ...,
        request_params: global___RequestParams | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["description", b"description", "display_name", b"display_name", "key", b"key", "request_params", b"request_params"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["description", b"description", "display_name", b"display_name", "key", b"key", "request", b"request", "request_params", b"request_params"]) -> None: ...

global___WorkspaceConfig = WorkspaceConfig

@typing.final
class Workspace(google.protobuf.message.Message):
    """Workspace holds the status of a workspace."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    CREATED_AT_FIELD_NUMBER: builtins.int
    CREATED_BY_FIELD_NUMBER: builtins.int
    LAST_MODIFIED_AT_FIELD_NUMBER: builtins.int
    LAST_MODIFIED_BY_FIELD_NUMBER: builtins.int
    STATE_FIELD_NUMBER: builtins.int
    LAST_BUILD_ID_FIELD_NUMBER: builtins.int
    RESPONSES_FIELD_NUMBER: builtins.int
    CC_IDS_FIELD_NUMBER: builtins.int
    NEEDS_BUILD_FIELD_NUMBER: builtins.int
    LAST_REBASED_AT_FIELD_NUMBER: builtins.int
    NEEDS_REBASE_FIELD_NUMBER: builtins.int
    DISPLAY_NAME_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    state: global___WorkspaceState.ValueType
    """state describes the status of the workspace."""
    @property
    def key(self) -> global___WorkspaceKey:
        """key identifies the workspace."""

    @property
    def created_at(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """created_at indicates when the workspace was created."""

    @property
    def created_by(self) -> google.protobuf.wrappers_pb2.StringValue:
        """created_by indicates who created the workspace."""

    @property
    def last_modified_at(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """last_modified_at indicates when the workspace was last updated."""

    @property
    def last_modified_by(self) -> google.protobuf.wrappers_pb2.StringValue:
        """last_modified_by indicates who last updated the workspace."""

    @property
    def last_build_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """last_build_id is the last build ID that was set in a WorkspaceBuild
        for this workspace.
        """

    @property
    def responses(self) -> global___Responses:
        """responses are the responses for all requests that have been executed
        thusfar for this workspace.
        """

    @property
    def cc_ids(self) -> fmp.wrappers_pb2.RepeatedString:
        """cc_ids are the IDs of any change controls that were created as a result
        of submitting this workspace.
        """

    @property
    def needs_build(self) -> google.protobuf.wrappers_pb2.BoolValue:
        """needs_build indicates whether a rebuild of the workspace is necessary
        in order to submit it.
        """

    @property
    def last_rebased_at(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """last_rebased_at indicates when the workspace was last rebased."""

    @property
    def needs_rebase(self) -> google.protobuf.wrappers_pb2.BoolValue:
        """needs_rebase indicates whether a rebase of the workspace is necessary
        in order to submit it.
        """

    @property
    def display_name(self) -> google.protobuf.wrappers_pb2.StringValue:
        """display_name is the user-defined name of the workspace."""

    @property
    def description(self) -> google.protobuf.wrappers_pb2.StringValue:
        """description is a brief description of the workspace."""

    def __init__(
        self,
        *,
        key: global___WorkspaceKey | None = ...,
        created_at: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        created_by: google.protobuf.wrappers_pb2.StringValue | None = ...,
        last_modified_at: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        last_modified_by: google.protobuf.wrappers_pb2.StringValue | None = ...,
        state: global___WorkspaceState.ValueType = ...,
        last_build_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
        responses: global___Responses | None = ...,
        cc_ids: fmp.wrappers_pb2.RepeatedString | None = ...,
        needs_build: google.protobuf.wrappers_pb2.BoolValue | None = ...,
        last_rebased_at: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        needs_rebase: google.protobuf.wrappers_pb2.BoolValue | None = ...,
        display_name: google.protobuf.wrappers_pb2.StringValue | None = ...,
        description: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["cc_ids", b"cc_ids", "created_at", b"created_at", "created_by", b"created_by", "description", b"description", "display_name", b"display_name", "key", b"key", "last_build_id", b"last_build_id", "last_modified_at", b"last_modified_at", "last_modified_by", b"last_modified_by", "last_rebased_at", b"last_rebased_at", "needs_build", b"needs_build", "needs_rebase", b"needs_rebase", "responses", b"responses"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["cc_ids", b"cc_ids", "created_at", b"created_at", "created_by", b"created_by", "description", b"description", "display_name", b"display_name", "key", b"key", "last_build_id", b"last_build_id", "last_modified_at", b"last_modified_at", "last_modified_by", b"last_modified_by", "last_rebased_at", b"last_rebased_at", "needs_build", b"needs_build", "needs_rebase", b"needs_rebase", "responses", b"responses", "state", b"state"]) -> None: ...

global___Workspace = Workspace

@typing.final
class InputError(google.protobuf.message.Message):
    """InputError holds the details for an error on a studio input field or value."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    FIELD_ID_FIELD_NUMBER: builtins.int
    PATH_FIELD_NUMBER: builtins.int
    MEMBERS_FIELD_NUMBER: builtins.int
    MESSAGE_FIELD_NUMBER: builtins.int
    @property
    def field_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """field_id is the ID of the input field."""

    @property
    def path(self) -> fmp.wrappers_pb2.RepeatedString:
        """path is the path leading up to the input field."""

    @property
    def members(self) -> fmp.wrappers_pb2.RepeatedString:
        """members are the members of the input field (if it is a group)."""

    @property
    def message(self) -> google.protobuf.wrappers_pb2.StringValue:
        """message is the error message."""

    def __init__(
        self,
        *,
        field_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
        path: fmp.wrappers_pb2.RepeatedString | None = ...,
        members: fmp.wrappers_pb2.RepeatedString | None = ...,
        message: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["field_id", b"field_id", "members", b"members", "message", b"message", "path", b"path"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["field_id", b"field_id", "members", b"members", "message", b"message", "path", b"path"]) -> None: ...

global___InputError = InputError

@typing.final
class InputErrors(google.protobuf.message.Message):
    """InputErrors is a list of InputError."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUES_FIELD_NUMBER: builtins.int
    @property
    def values(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___InputError]:
        """values is a list of InputError."""

    def __init__(
        self,
        *,
        values: collections.abc.Iterable[global___InputError] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["values", b"values"]) -> None: ...

global___InputErrors = InputErrors

@typing.final
class InputValidationResult(google.protobuf.message.Message):
    """InputValidationResult holds the result of an input validation build stage."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    INPUT_SCHEMA_ERRORS_FIELD_NUMBER: builtins.int
    INPUT_VALUE_ERRORS_FIELD_NUMBER: builtins.int
    OTHER_ERRORS_FIELD_NUMBER: builtins.int
    INPUT_VALUE_WARNINGS_FIELD_NUMBER: builtins.int
    @property
    def input_schema_errors(self) -> global___InputErrors:
        """input_schema_errors are errors for fields in the input schema."""

    @property
    def input_value_errors(self) -> global___InputErrors:
        """input_value_errors are errors for values assigned to fields in the input schema."""

    @property
    def other_errors(self) -> fmp.wrappers_pb2.RepeatedString:
        """other_errors are other miscellaneous errors."""

    @property
    def input_value_warnings(self) -> global___InputErrors:
        """input_value_warnings are warnings for values assigned to fields in the input schema."""

    def __init__(
        self,
        *,
        input_schema_errors: global___InputErrors | None = ...,
        input_value_errors: global___InputErrors | None = ...,
        other_errors: fmp.wrappers_pb2.RepeatedString | None = ...,
        input_value_warnings: global___InputErrors | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["input_schema_errors", b"input_schema_errors", "input_value_errors", b"input_value_errors", "input_value_warnings", b"input_value_warnings", "other_errors", b"other_errors"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["input_schema_errors", b"input_schema_errors", "input_value_errors", b"input_value_errors", "input_value_warnings", b"input_value_warnings", "other_errors", b"other_errors"]) -> None: ...

global___InputValidationResult = InputValidationResult

@typing.final
class InputValidationResults(google.protobuf.message.Message):
    """InputValidationResults is a collection of InputValidationResult (one per studio)."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class ValuesEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> global___InputValidationResult: ...
        def __init__(
            self,
            *,
            key: builtins.str = ...,
            value: global___InputValidationResult | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    VALUES_FIELD_NUMBER: builtins.int
    @property
    def values(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, global___InputValidationResult]:
        """values is map from studio ID to InputValidationResult."""

    def __init__(
        self,
        *,
        values: collections.abc.Mapping[builtins.str, global___InputValidationResult] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["values", b"values"]) -> None: ...

global___InputValidationResults = InputValidationResults

@typing.final
class TemplateError(google.protobuf.message.Message):
    """TemplateError holds details for an error that occured while evaluating a studio
    template against its inputs.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    LINE_NUM_FIELD_NUMBER: builtins.int
    EXCEPTION_FIELD_NUMBER: builtins.int
    DETAIL_FIELD_NUMBER: builtins.int
    EXCEPTION_MSG_FIELD_NUMBER: builtins.int
    @property
    def line_num(self) -> google.protobuf.wrappers_pb2.UInt32Value:
        """line_num is the number of the line on which the error occurred."""

    @property
    def exception(self) -> google.protobuf.wrappers_pb2.StringValue:
        """exception is the type of the exception thrown during the script execution.
        E.g., AssertionError, etc.
        """

    @property
    def detail(self) -> google.protobuf.wrappers_pb2.StringValue:
        """detail holds the details of the exception. E.g., a full backtrace."""

    @property
    def exception_msg(self) -> google.protobuf.wrappers_pb2.StringValue:
        """exception_msg is the message of the exception thrown during the script execution."""

    def __init__(
        self,
        *,
        line_num: google.protobuf.wrappers_pb2.UInt32Value | None = ...,
        exception: google.protobuf.wrappers_pb2.StringValue | None = ...,
        detail: google.protobuf.wrappers_pb2.StringValue | None = ...,
        exception_msg: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["detail", b"detail", "exception", b"exception", "exception_msg", b"exception_msg", "line_num", b"line_num"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["detail", b"detail", "exception", b"exception", "exception_msg", b"exception_msg", "line_num", b"line_num"]) -> None: ...

global___TemplateError = TemplateError

@typing.final
class TemplateErrors(google.protobuf.message.Message):
    """TemplateErrors is a list of TemplateError."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUES_FIELD_NUMBER: builtins.int
    @property
    def values(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___TemplateError]:
        """values is a list of TemplateError."""

    def __init__(
        self,
        *,
        values: collections.abc.Iterable[global___TemplateError] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["values", b"values"]) -> None: ...

global___TemplateErrors = TemplateErrors

@typing.final
class ConfigletBuildResult(google.protobuf.message.Message):
    """ConfigletBuildResult holds the result of a configlet build stage."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TEMPLATE_ERRORS_FIELD_NUMBER: builtins.int
    GENERATED_CONFIG_FIELD_NUMBER: builtins.int
    OTHER_ERROR_FIELD_NUMBER: builtins.int
    EXECUTION_ID_FIELD_NUMBER: builtins.int
    INPUT_ERRORS_FIELD_NUMBER: builtins.int
    @property
    def template_errors(self) -> global___TemplateErrors:
        """template_errors are errors that occured during studio template evaluation."""

    @property
    def generated_config(self) -> google.protobuf.wrappers_pb2.StringValue:
        """generated_config is the EOS CLI config that was generated from the stage."""

    @property
    def other_error(self) -> google.protobuf.wrappers_pb2.StringValue:
        """other_error is any other miscellaneous error."""

    @property
    def execution_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """execution_id is the unique ID for the execution of the template. This ID
        can be used to retrieve logs generated by the template.
        """

    @property
    def input_errors(self) -> global___InputErrors:
        """input_errors are errors in input fields that are raised by the template."""

    def __init__(
        self,
        *,
        template_errors: global___TemplateErrors | None = ...,
        generated_config: google.protobuf.wrappers_pb2.StringValue | None = ...,
        other_error: google.protobuf.wrappers_pb2.StringValue | None = ...,
        execution_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
        input_errors: global___InputErrors | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["execution_id", b"execution_id", "generated_config", b"generated_config", "input_errors", b"input_errors", "other_error", b"other_error", "template_errors", b"template_errors"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["execution_id", b"execution_id", "generated_config", b"generated_config", "input_errors", b"input_errors", "other_error", b"other_error", "template_errors", b"template_errors"]) -> None: ...

global___ConfigletBuildResult = ConfigletBuildResult

@typing.final
class ConfigletBuildResults(google.protobuf.message.Message):
    """ConfigletBuildResults is a collection of ConfigletBuildResult (one per studio)."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class ValuesEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> global___ConfigletBuildResult: ...
        def __init__(
            self,
            *,
            key: builtins.str = ...,
            value: global___ConfigletBuildResult | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    VALUES_FIELD_NUMBER: builtins.int
    @property
    def values(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, global___ConfigletBuildResult]:
        """values is a map from studio ID to ConfigletBuildResult."""

    def __init__(
        self,
        *,
        values: collections.abc.Mapping[builtins.str, global___ConfigletBuildResult] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["values", b"values"]) -> None: ...

global___ConfigletBuildResults = ConfigletBuildResults

@typing.final
class ConfigValidationResult(google.protobuf.message.Message):
    """ConfigValidationResult holds the result of a config validation stage."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SUMMARY_FIELD_NUMBER: builtins.int
    ERRORS_FIELD_NUMBER: builtins.int
    WARNINGS_FIELD_NUMBER: builtins.int
    CONFIG_SOURCES_FIELD_NUMBER: builtins.int
    ONLY_FILTER_INPUTS_CHANGED_FIELD_NUMBER: builtins.int
    @property
    def summary(self) -> arista.configstatus.v1.configstatus_pb2.ConfigSummary:
        """summary is a summary of the changes to the previous config."""

    @property
    def errors(self) -> arista.configstatus.v1.configstatus_pb2.ConfigErrors:
        """errors are any errors detected in the generated config."""

    @property
    def warnings(self) -> arista.configstatus.v1.configstatus_pb2.ConfigErrors:
        """warnings are any warnings about the generated config."""

    @property
    def config_sources(self) -> arista.configstatus.v1.configstatus_pb2.ConfigSources:
        """config_sources identify the entities that generated the config."""

    @property
    def only_filter_inputs_changed(self) -> google.protobuf.wrappers_pb2.BoolValue:
        """only_filter_inputs_changed indicates there is a change in filters
        but no change in the config or no config sources found.
        """

    def __init__(
        self,
        *,
        summary: arista.configstatus.v1.configstatus_pb2.ConfigSummary | None = ...,
        errors: arista.configstatus.v1.configstatus_pb2.ConfigErrors | None = ...,
        warnings: arista.configstatus.v1.configstatus_pb2.ConfigErrors | None = ...,
        config_sources: arista.configstatus.v1.configstatus_pb2.ConfigSources | None = ...,
        only_filter_inputs_changed: google.protobuf.wrappers_pb2.BoolValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["config_sources", b"config_sources", "errors", b"errors", "only_filter_inputs_changed", b"only_filter_inputs_changed", "summary", b"summary", "warnings", b"warnings"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["config_sources", b"config_sources", "errors", b"errors", "only_filter_inputs_changed", b"only_filter_inputs_changed", "summary", b"summary", "warnings", b"warnings"]) -> None: ...

global___ConfigValidationResult = ConfigValidationResult

@typing.final
class ImageValidationResult(google.protobuf.message.Message):
    """ImageValidationResult holds the result of an image validation stage."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SUMMARY_FIELD_NUMBER: builtins.int
    ERRORS_FIELD_NUMBER: builtins.int
    WARNINGS_FIELD_NUMBER: builtins.int
    IMAGE_INPUT_ERROR_FIELD_NUMBER: builtins.int
    INFOS_FIELD_NUMBER: builtins.int
    @property
    def summary(self) -> arista.imagestatus.v1.imagestatus_pb2.ImageSummary:
        """summary is a summary of the changes to the previous image."""

    @property
    def errors(self) -> arista.imagestatus.v1.imagestatus_pb2.ImageErrors:
        """errors are any errors detected in the generated image."""

    @property
    def warnings(self) -> arista.imagestatus.v1.imagestatus_pb2.ImageWarnings:
        """warnings are any warnings about the generated image."""

    @property
    def image_input_error(self) -> google.protobuf.wrappers_pb2.StringValue:
        """image_input_error indicates any errors in image inputs."""

    @property
    def infos(self) -> arista.imagestatus.v1.imagestatus_pb2.ImageInfos:
        """infos are any info messages about the generated image."""

    def __init__(
        self,
        *,
        summary: arista.imagestatus.v1.imagestatus_pb2.ImageSummary | None = ...,
        errors: arista.imagestatus.v1.imagestatus_pb2.ImageErrors | None = ...,
        warnings: arista.imagestatus.v1.imagestatus_pb2.ImageWarnings | None = ...,
        image_input_error: google.protobuf.wrappers_pb2.StringValue | None = ...,
        infos: arista.imagestatus.v1.imagestatus_pb2.ImageInfos | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["errors", b"errors", "image_input_error", b"image_input_error", "infos", b"infos", "summary", b"summary", "warnings", b"warnings"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["errors", b"errors", "image_input_error", b"image_input_error", "infos", b"infos", "summary", b"summary", "warnings", b"warnings"]) -> None: ...

global___ImageValidationResult = ImageValidationResult

@typing.final
class ConfigSyncResult(google.protobuf.message.Message):
    """ConfigSyncResult holds the result of config sync operation."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SUMMARY_FIELD_NUMBER: builtins.int
    ERRORS_FIELD_NUMBER: builtins.int
    CONFIG_SOURCES_FIELD_NUMBER: builtins.int
    @property
    def summary(self) -> arista.configstatus.v1.configstatus_pb2.ConfigSummary:
        """summary is a summary of the changes to the running config."""

    @property
    def errors(self) -> arista.configstatus.v1.configstatus_pb2.ConfigErrors:
        """errors are any errors detected during sync."""

    @property
    def config_sources(self) -> arista.configstatus.v1.configstatus_pb2.ConfigSources:
        """config_sources identify the entities that generated the designed config."""

    def __init__(
        self,
        *,
        summary: arista.configstatus.v1.configstatus_pb2.ConfigSummary | None = ...,
        errors: arista.configstatus.v1.configstatus_pb2.ConfigErrors | None = ...,
        config_sources: arista.configstatus.v1.configstatus_pb2.ConfigSources | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["config_sources", b"config_sources", "errors", b"errors", "summary", b"summary"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["config_sources", b"config_sources", "errors", b"errors", "summary", b"summary"]) -> None: ...

global___ConfigSyncResult = ConfigSyncResult

@typing.final
class BuildStageState(google.protobuf.message.Message):
    """BuildStageState holds the state per build stage."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class ValuesEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: global___BuildState.ValueType
        def __init__(
            self,
            *,
            key: builtins.str = ...,
            value: global___BuildState.ValueType = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    VALUES_FIELD_NUMBER: builtins.int
    @property
    def values(self) -> google.protobuf.internal.containers.ScalarMap[builtins.str, global___BuildState.ValueType]:
        """values is a map from build stage to build state.
        The possible keys to this map are BUILD_STAGE_UNSPECIFIED,
        BUILD_STAGE_INPUT_VALIDATION, BUILD_STAGE_CONFIGLET_BUILD,
        BUILD_STAGE_CONFIG_VALIDATION and BUILD_STAGE_IMAGE_VALIDATION.
        """

    def __init__(
        self,
        *,
        values: collections.abc.Mapping[builtins.str, global___BuildState.ValueType] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["values", b"values"]) -> None: ...

global___BuildStageState = BuildStageState

@typing.final
class AuthzResult(google.protobuf.message.Message):
    """AuthzResult has the result of the authorization check for workspace changes."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    HAS_UNAUTHORIZED_TAG_CHANGE_FIELD_NUMBER: builtins.int
    HAS_UNAUTHORIZED_DEVICE_CHANGE_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    @property
    def has_unauthorized_tag_change(self) -> google.protobuf.wrappers_pb2.BoolValue:
        """has_unauthorized_tag_change is true when there is a tag assignment that results
        in change in permissions and the subject is not authorized to do it.
        """

    @property
    def has_unauthorized_device_change(self) -> google.protobuf.wrappers_pb2.BoolValue:
        """has_unauthorized_device_change is true when there is atleast 1 device
        for which the subject doesn't have provision permission.
        """

    @property
    def error(self) -> google.protobuf.wrappers_pb2.StringValue:
        """error is an error message that is set when either of the above values
        are true.
        """

    def __init__(
        self,
        *,
        has_unauthorized_tag_change: google.protobuf.wrappers_pb2.BoolValue | None = ...,
        has_unauthorized_device_change: google.protobuf.wrappers_pb2.BoolValue | None = ...,
        error: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["error", b"error", "has_unauthorized_device_change", b"has_unauthorized_device_change", "has_unauthorized_tag_change", b"has_unauthorized_tag_change"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["error", b"error", "has_unauthorized_device_change", b"has_unauthorized_device_change", "has_unauthorized_tag_change", b"has_unauthorized_tag_change"]) -> None: ...

global___AuthzResult = AuthzResult

@typing.final
class StudioBuildDetails(google.protobuf.message.Message):
    """StudioBuildDetails is a collection of per studio results that are not specific to a device."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    INPUT_VALIDATION_RESULTS_FIELD_NUMBER: builtins.int
    @property
    def input_validation_results(self) -> global___InputValidationResults:
        """input_validation_results is a map from studio ID to InputValidationResult."""

    def __init__(
        self,
        *,
        input_validation_results: global___InputValidationResults | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["input_validation_results", b"input_validation_results"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["input_validation_results", b"input_validation_results"]) -> None: ...

global___StudioBuildDetails = StudioBuildDetails

@typing.final
class WorkspaceBuildKey(google.protobuf.message.Message):
    """WorkspaceBuildKey uniquely identifies a build for a workspace."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    WORKSPACE_ID_FIELD_NUMBER: builtins.int
    BUILD_ID_FIELD_NUMBER: builtins.int
    @property
    def workspace_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """workspace_id is the ID of the workspace."""

    @property
    def build_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """build_id is the ID of the build."""

    def __init__(
        self,
        *,
        workspace_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
        build_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["build_id", b"build_id", "workspace_id", b"workspace_id"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["build_id", b"build_id", "workspace_id", b"workspace_id"]) -> None: ...

global___WorkspaceBuildKey = WorkspaceBuildKey

@typing.final
class WorkspaceBuild(google.protobuf.message.Message):
    """WorkspaceBuild holds the details for a build of a workspace."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    STATE_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    BUILT_BY_FIELD_NUMBER: builtins.int
    AUTHZ_RESULT_FIELD_NUMBER: builtins.int
    STUDIO_BUILD_DETAILS_FIELD_NUMBER: builtins.int
    state: global___BuildState.ValueType
    """state is the execution status of the build."""
    @property
    def key(self) -> global___WorkspaceBuildKey:
        """key identifies the build."""

    @property
    def error(self) -> google.protobuf.wrappers_pb2.StringValue:
        """error is an error message that is set if the build fails early before
        the per-device build result is computed.
        """

    @property
    def built_by(self) -> google.protobuf.wrappers_pb2.StringValue:
        """built_by is the details of subject who built the workspace."""

    @property
    def authz_result(self) -> global___AuthzResult:
        """authz_result has the result of authorization check."""

    @property
    def studio_build_details(self) -> global___StudioBuildDetails:
        """studio_build_details has per studio results that are not specific to a device."""

    def __init__(
        self,
        *,
        key: global___WorkspaceBuildKey | None = ...,
        state: global___BuildState.ValueType = ...,
        error: google.protobuf.wrappers_pb2.StringValue | None = ...,
        built_by: google.protobuf.wrappers_pb2.StringValue | None = ...,
        authz_result: global___AuthzResult | None = ...,
        studio_build_details: global___StudioBuildDetails | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["authz_result", b"authz_result", "built_by", b"built_by", "error", b"error", "key", b"key", "studio_build_details", b"studio_build_details"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["authz_result", b"authz_result", "built_by", b"built_by", "error", b"error", "key", b"key", "state", b"state", "studio_build_details", b"studio_build_details"]) -> None: ...

global___WorkspaceBuild = WorkspaceBuild

@typing.final
class WorkspaceBuildDetailsKey(google.protobuf.message.Message):
    """WorkspaceBuildDetailsKey uniquely identifies a build for a particular
    device in a workspace.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    WORKSPACE_ID_FIELD_NUMBER: builtins.int
    BUILD_ID_FIELD_NUMBER: builtins.int
    DEVICE_ID_FIELD_NUMBER: builtins.int
    @property
    def workspace_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """workspace_id is the ID of the workspace."""

    @property
    def build_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """build_id is the ID of the build."""

    @property
    def device_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """device_id is the ID of the device."""

    def __init__(
        self,
        *,
        workspace_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
        build_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
        device_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["build_id", b"build_id", "device_id", b"device_id", "workspace_id", b"workspace_id"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["build_id", b"build_id", "device_id", b"device_id", "workspace_id", b"workspace_id"]) -> None: ...

global___WorkspaceBuildDetailsKey = WorkspaceBuildDetailsKey

@typing.final
class WorkspaceBuildDetails(google.protobuf.message.Message):
    """WorkspaceBuildDetails holds the details for a build of a device in a workspace."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    STATE_FIELD_NUMBER: builtins.int
    STAGE_FIELD_NUMBER: builtins.int
    INPUT_VALIDATION_RESULTS_FIELD_NUMBER: builtins.int
    CONFIGLET_BUILD_RESULTS_FIELD_NUMBER: builtins.int
    CONFIG_VALIDATION_RESULT_FIELD_NUMBER: builtins.int
    IMAGE_VALIDATION_RESULT_FIELD_NUMBER: builtins.int
    CONFIG_VALIDATION_SKIP_CAUSE_FIELD_NUMBER: builtins.int
    IMAGE_VALIDATION_SKIP_CAUSE_FIELD_NUMBER: builtins.int
    BUILD_STAGE_STATE_FIELD_NUMBER: builtins.int
    AUTHZ_STATUS_FIELD_NUMBER: builtins.int
    CONFIG_SYNC_RESULT_FIELD_NUMBER: builtins.int
    CONFIG_SYNC_SKIP_CAUSE_FIELD_NUMBER: builtins.int
    state: global___BuildState.ValueType
    """state is the execution status of the build."""
    stage: global___BuildStage.ValueType
    """stage is the stage of the build."""
    config_validation_skip_cause: global___ConfigValidationSkipCause.ValueType
    """config_validation_skip_cause is the reason, if any, that the config
    validation stage was skipped.
    """
    image_validation_skip_cause: global___ImageValidationSkipCause.ValueType
    """image_validation_skip_cause is the reason, if any, that the image
    validation stage was skipped.
    """
    authz_status: global___DeviceAuthzStatus.ValueType
    """authz_status is the status of provision permission for the device."""
    config_sync_skip_cause: global___ConfigSyncSkipCause.ValueType
    """config_sync_skip_cause is the reason for skipping the config sync."""
    @property
    def key(self) -> global___WorkspaceBuildDetailsKey:
        """key identifies the build."""

    @property
    def input_validation_results(self) -> global___InputValidationResults:
        """input_validation_results are the results of the input validation stage."""

    @property
    def configlet_build_results(self) -> global___ConfigletBuildResults:
        """configlet_build_results are the results of the configlet build stage."""

    @property
    def config_validation_result(self) -> global___ConfigValidationResult:
        """config_validation_result is the result of the config validation stage."""

    @property
    def image_validation_result(self) -> global___ImageValidationResult:
        """image_validation_result is the result of the image validation stage."""

    @property
    def build_stage_state(self) -> global___BuildStageState:
        """build_stage_state is the state for each build stage."""

    @property
    def config_sync_result(self) -> global___ConfigSyncResult:
        """config_sync_result is the result of the config sync."""

    def __init__(
        self,
        *,
        key: global___WorkspaceBuildDetailsKey | None = ...,
        state: global___BuildState.ValueType = ...,
        stage: global___BuildStage.ValueType = ...,
        input_validation_results: global___InputValidationResults | None = ...,
        configlet_build_results: global___ConfigletBuildResults | None = ...,
        config_validation_result: global___ConfigValidationResult | None = ...,
        image_validation_result: global___ImageValidationResult | None = ...,
        config_validation_skip_cause: global___ConfigValidationSkipCause.ValueType = ...,
        image_validation_skip_cause: global___ImageValidationSkipCause.ValueType = ...,
        build_stage_state: global___BuildStageState | None = ...,
        authz_status: global___DeviceAuthzStatus.ValueType = ...,
        config_sync_result: global___ConfigSyncResult | None = ...,
        config_sync_skip_cause: global___ConfigSyncSkipCause.ValueType = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["build_stage_state", b"build_stage_state", "config_sync_result", b"config_sync_result", "config_validation_result", b"config_validation_result", "configlet_build_results", b"configlet_build_results", "image_validation_result", b"image_validation_result", "input_validation_results", b"input_validation_results", "key", b"key"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["authz_status", b"authz_status", "build_stage_state", b"build_stage_state", "config_sync_result", b"config_sync_result", "config_sync_skip_cause", b"config_sync_skip_cause", "config_validation_result", b"config_validation_result", "config_validation_skip_cause", b"config_validation_skip_cause", "configlet_build_results", b"configlet_build_results", "image_validation_result", b"image_validation_result", "image_validation_skip_cause", b"image_validation_skip_cause", "input_validation_results", b"input_validation_results", "key", b"key", "stage", b"stage", "state", b"state"]) -> None: ...

global___WorkspaceBuildDetails = WorkspaceBuildDetails

@typing.final
class WorkspaceSyncKey(google.protobuf.message.Message):
    """WorkspaceSyncKey uniquely identifies sync operations to be performed
    in a workspace.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    WORKSPACE_ID_FIELD_NUMBER: builtins.int
    SYNC_OPERATION_FIELD_NUMBER: builtins.int
    sync_operation: global___SyncOperation.ValueType
    """sync_operation is type of sync operation to be performed on devices."""
    @property
    def workspace_id(self) -> google.protobuf.wrappers_pb2.StringValue:
        """workspace_id is the ID of the workspace."""

    def __init__(
        self,
        *,
        workspace_id: google.protobuf.wrappers_pb2.StringValue | None = ...,
        sync_operation: global___SyncOperation.ValueType = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["workspace_id", b"workspace_id"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["sync_operation", b"sync_operation", "workspace_id", b"workspace_id"]) -> None: ...

global___WorkspaceSyncKey = WorkspaceSyncKey

@typing.final
class WorkspaceSyncConfig(google.protobuf.message.Message):
    """WorkspaceSyncConfig holds the list of devices to be synced in workspace."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    DEVICE_IDS_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> global___WorkspaceSyncKey:
        """key uniquely identifies sync operations to be performed in workspace."""

    @property
    def device_ids(self) -> fmp.wrappers_pb2.RepeatedString:
        """device_ids is the list of device Ids to be synced in the workspace."""

    def __init__(
        self,
        *,
        key: global___WorkspaceSyncKey | None = ...,
        device_ids: fmp.wrappers_pb2.RepeatedString | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["device_ids", b"device_ids", "key", b"key"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["device_ids", b"device_ids", "key", b"key"]) -> None: ...

global___WorkspaceSyncConfig = WorkspaceSyncConfig
