"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Copyright (c) 2020 Arista Networks, Inc.
Use of this source code is governed by the Apache License 2.0
that can be found in the COPYING file.
"""

import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import google.protobuf.timestamp_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _ReplicationState:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _ReplicationStateEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_ReplicationState.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    NO_REPLICATION: _ReplicationState.ValueType  # 0
    REPLICATE: _ReplicationState.ValueType  # 1
    CACHE_REPLICATE: _ReplicationState.ValueType  # 2

class ReplicationState(_ReplicationState, metaclass=_ReplicationStateEnumTypeWrapper):
    """ReplicationState represent the level of replication we want to
    apply on a notification. By default there is no replication.
    If CACHE_REPLICATE is used then that notification will be
    replicated to all the other clusters connected to the one
    where that notification is currently published, and the
    caches of the components running in these clusters will be
    synced together.
    REPLICATE is like CACHE_REPLICATE but without the cache
    synchronization.
    """

NO_REPLICATION: ReplicationState.ValueType  # 0
REPLICATE: ReplicationState.ValueType  # 1
CACHE_REPLICATE: ReplicationState.ValueType  # 2
global___ReplicationState = ReplicationState

@typing.final
class Notification(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class Update(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.bytes
        """encoded"""
        value: builtins.bytes
        """encoded"""
        def __init__(
            self,
            *,
            key: builtins.bytes = ...,
            value: builtins.bytes = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    TIMESTAMP_FIELD_NUMBER: builtins.int
    PATH_FIELD_NUMBER: builtins.int
    DELETE_ALL_FIELD_NUMBER: builtins.int
    DELETES_FIELD_NUMBER: builtins.int
    UPDATES_FIELD_NUMBER: builtins.int
    RETRACTS_FIELD_NUMBER: builtins.int
    PATH_ELEMENTS_FIELD_NUMBER: builtins.int
    path: builtins.str
    """Deprecated"""
    delete_all: builtins.bool
    @property
    def timestamp(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Timestamp in nanoseconds resolution."""

    @property
    def deletes(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.bytes]:
        """encoded"""

    @property
    def updates(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Notification.Update]: ...
    @property
    def retracts(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.bytes]:
        """encoded"""

    @property
    def path_elements(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.bytes]:
        """encoded"""

    def __init__(
        self,
        *,
        timestamp: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        path: builtins.str = ...,
        delete_all: builtins.bool = ...,
        deletes: collections.abc.Iterable[builtins.bytes] | None = ...,
        updates: collections.abc.Iterable[global___Notification.Update] | None = ...,
        retracts: collections.abc.Iterable[builtins.bytes] | None = ...,
        path_elements: collections.abc.Iterable[builtins.bytes] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["timestamp", b"timestamp"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["delete_all", b"delete_all", "deletes", b"deletes", "path", b"path", "path_elements", b"path_elements", "retracts", b"retracts", "timestamp", b"timestamp", "updates", b"updates"]) -> None: ...

global___Notification = Notification

@typing.final
class Dataset(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TYPE_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    PARENT_FIELD_NUMBER: builtins.int
    type: builtins.str
    name: builtins.str
    @property
    def parent(self) -> global___Dataset: ...
    def __init__(
        self,
        *,
        type: builtins.str = ...,
        name: builtins.str = ...,
        parent: global___Dataset | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["parent", b"parent"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["name", b"name", "parent", b"parent", "type", b"type"]) -> None: ...

global___Dataset = Dataset

@typing.final
class NotificationBatch(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class MetadataEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: builtins.str
        def __init__(
            self,
            *,
            key: builtins.str = ...,
            value: builtins.str = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    D_FIELD_NUMBER: builtins.int
    NOTIFICATIONS_FIELD_NUMBER: builtins.int
    DATASET_FIELD_NUMBER: builtins.int
    METADATA_FIELD_NUMBER: builtins.int
    REPLICATE_FIELD_NUMBER: builtins.int
    d: builtins.str
    """TODO: deprecate, for now just assume
    that type is "device"
    """
    replicate: global___ReplicationState.ValueType
    @property
    def notifications(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Notification]: ...
    @property
    def dataset(self) -> global___Dataset: ...
    @property
    def metadata(self) -> google.protobuf.internal.containers.ScalarMap[builtins.str, builtins.str]: ...
    def __init__(
        self,
        *,
        d: builtins.str = ...,
        notifications: collections.abc.Iterable[global___Notification] | None = ...,
        dataset: global___Dataset | None = ...,
        metadata: collections.abc.Mapping[builtins.str, builtins.str] | None = ...,
        replicate: global___ReplicationState.ValueType = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["dataset", b"dataset"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["d", b"d", "dataset", b"dataset", "metadata", b"metadata", "notifications", b"notifications", "replicate", b"replicate"]) -> None: ...

global___NotificationBatch = NotificationBatch
